angular.module("joinnet", ["pascalprecht.translate"]).service("JoinNet", ["$rootScope", "jnjContent", "hmtgAlert", "hmtgHelper", "joinnetHelper", "$translate", "$modal", "chat", "playback", "audio_playback", "hmtgSound", "video_playback", "appSetting", "video_recving", function(a, e, d, b, h, k, g, s, m, r, q, l, f, c) {
  var t = this;
  this.net_init_finished = !1;
  this.user_array = {};
  this.auto_reconnect_start_tick = 0;
  this.auto_reconnect_alert_item = null;
  this.auto_reconnect_count = 0;
  this.auto_reconnect_no_alert_count = 2;
  this.auto_reconnect_max_time_window = 6E5;
  var p = hmtg.jnkernel;
  p.jn_callback_UpdateStatus = p.jn_callback_UpdateStatus = function(a) {
    a == hmtg.config.JN_CONNECTION_ESTABLISHED && t.resetAutoReconnect();
    var f = {timeout:20, update:function() {
      return k.instant(h.errorcode2id(a));
    }};
    f.text = f.update();
    f.type = "success";
    d.update_status_item(f);
  };
  p.jn_callback_UpdateStatus_MessageBox = p.jn_callback_UpdateStatus_MessageBox = function(f) {
    d.update_status_item({});
    a.msgbox_text = "(" + f + ") " + k.instant(h.errorcode2id(f));
    a.hide_cancel = !0;
    a.timeout = 0;
    g.open({templateUrl:"appMessageBox.html", scope:a, controller:"AppMessageBoxModalCtrl", size:"", backdrop:"static", resolve:{}}).result.then(function(a) {
    }, function() {
    });
  };
  p.jn_callback_ErrorWrongVersion = p.jn_callback_ErrorWrongVersion = function(f, c, l) {
    d.update_status_item({});
    a.msgbox_text = "(" + (hmtg.config.JN_ERROR_BASE - 256 + f) + ") " + k.instant("IDS_FILE_WRONG_VERSION").replace("%d", c).replace("%d", l);
    a.hide_cancel = !0;
    a.timeout = 0;
    g.open({templateUrl:"appMessageBox.html", scope:a, controller:"AppMessageBoxModalCtrl", size:"", backdrop:"static", resolve:{}}).result.then(function(a) {
    }, function() {
    });
  };
  this.resetAutoReconnect = function() {
    this.auto_reconnect_count = 0;
    this.auto_reconnect_alert_item && (d.remove_link_item(this.auto_reconnect_alert_item), this.auto_reconnect_alert_item = null);
  };
  p.jn_callback_DisconnectFromMCU = p.jn_callback_DisconnectFromMCU = function(f) {
    d.update_status_item({});
    t.auto_reconnect_count++;
    1 == t.auto_reconnect_count && (t.auto_reconnect_start_tick = hmtg.util.GetTickCount());
    if (t.auto_reconnect_count <= t.auto_reconnect_no_alert_count) {
      setTimeout(function() {
        hmtg.jnkernel._jn_bConnected() || hmtg.jnkernel._jn_bConnecting() || (a.nav_item = "joinnet", a.tabs[2].active = !0, hmtg.jnkernel.jn_command_QuitConnection(), hmtg.jnkernel.jn_command_initconnectmedia(!0));
      }, 0);
    } else {
      if (!(hmtg.util.GetTickCount() - t.auto_reconnect_start_tick > t.auto_reconnect_max_time_window)) {
        f = 500 << t.auto_reconnect_count;
        6E4 < f && (f = 6E4);
        var c = {};
        c.timeout = f / 1E3;
        c.update = function() {
          return k.instant("ID_AUTO_RECONNECT_PROMPT");
        };
        c.text = c.update();
        c.type = "info";
        c.click = function(f) {
          t.auto_reconnect_count = 0;
          b.inside_angular++;
          clearTimeout(d.link_array[f].timeout_id);
          d.link_array.splice(f, 1);
          a.$broadcast(b.WM_UPDATE_ALERT);
          hmtg.jnkernel._jn_bConnected() || hmtg.jnkernel._jn_bConnecting() || (a.nav_item = "joinnet", a.tabs[2].active = !0, hmtg.jnkernel.jn_command_QuitConnection(), hmtg.jnkernel.jn_command_initconnectmedia(!0));
          b.inside_angular--;
        };
        c.timeout_action = function(f) {
          hmtg.jnkernel._jn_bConnected() || hmtg.jnkernel._jn_bConnecting() || (a.nav_item = "joinnet", a.tabs[2].active = !0, hmtg.jnkernel.jn_command_QuitConnection(), hmtg.jnkernel.jn_command_initconnectmedia(!0));
        };
        t.auto_reconnect_alert_item = c;
        d.add_link_item(c);
      }
    }
  };
  p.jn_callback_AddUser = p.jn_callback_AddUser = function(f) {
    l.add_user(f);
    a.$broadcast(b.WM_ADD_USER, f);
  };
  p.jn_callback_EventQuitSession = p.jn_callback_EventQuitSession = function() {
    s.event_quit_session();
    m.event_quit_session();
    r.event_quit_session();
    l.event_quit_session();
    a.$broadcast(b.WM_QUIT_SESSION);
  };
  p.jn_callback_EventStartSession = p.jn_callback_EventStartSession = function() {
    t.net_init_finished = !1;
    m.reset();
    hmtg.jnkernel._jn_iMaxVideoBitrate(f.use_max_video_bitrate ? 1E3 * f.max_video_bitrate : 1E7);
    hmtg.jnkernel._jn_iMaxAppdataBitrate(f.use_max_appdata_bitrate ? 1E3 * f.max_appdata_bitrate : 0);
    a.$broadcast(b.WM_START_SESSION);
  };
  p.jn_callback_ChatText = p.jn_callback_ChatText = function(a, f, c, d, l) {
    s.add_chat(a, f, c, d, l);
  };
  p.jn_callback_NetInitFinish = p.jn_callback_NetInitFinish = function() {
    t.net_init_finished = !0;
    l.net_init_finished();
    a.$broadcast(b.WM_NET_INIT_FINISH);
    p.jn_command_UpdateTextCodePage(65001);
    a.$broadcast(b.WM_CHANGE_CAP);
  };
  p.jn_callback_update_duration_str = p.jn_callback_update_duration_str = function() {
    a.$broadcast(b.WM_UPDATE_DURATION);
  };
  p.jn_callback_PlaybackInitStat = p.jn_callback_PlaybackInitStat = function(a, f, c, d) {
    m.init_stat(a, f, c, d);
  };
  p.jn_callback_PlaybackTickUpdate = p.jn_callback_PlaybackTickUpdate = function(f) {
    a.$broadcast(b.WM_PLAYBACK_TICK_UPDATE, f);
  };
  p.jn_callback_PlaybackRestart = p.jn_callback_PlaybackRestart = function() {
    s.event_quit_session();
    s.reset();
    m.restart();
    l.restart();
    a.$broadcast(b.WM_PLAYBACK_RESTART);
  };
  p.jn_callback_AudioPacketRecved = p.jn_callback_AudioPacketRecved = function(a, f, c) {
    0 == c && r.recv_audio(a, f, c);
  };
  p.jn_callback_VideoPacketRecved = p.jn_callback_VideoPacketRecved = function(a, f, c, d, p) {
    0 == c && l.recv_video(a, f, c, d, p);
  };
  p.jn_callback_UnknownMediaAlert = p.jn_callback_UnknownMediaAlert = function(a, f) {
    var c;
    switch(a) {
      case hmtg.config.AUDIO_DFLT:
        c = "AUDIO_DFLT[" + a + "]";
        break;
      case hmtg.config.AUDIO_ILBC:
        c = "AUDIO_ILBC[" + a + "]";
        break;
      case hmtg.config.AUDIO_G726:
        c = "AUDIO_G726[" + a + "]";
        break;
      case hmtg.config.AUDIO_G726_11:
        c = "AUDIO_G726_11[" + a + "]";
        break;
      case hmtg.config.VIDEO_DFLT:
        c = "VIDEO_DFLT[" + a + "]";
        break;
      default:
        c = k.instant("ID_UNKNOWN_CODEC") + "[" + a + "]";
    }
    q.ShowErrorPrompt(function() {
      return k.instant("ID_UNKNOWN_MEDIA").replace("#type#", c).replace("#name#", hmtg.util.decodeUtf8(f));
    }, 20);
  };
  p.jn_callback_NewTokenHolder = p.jn_callback_NewTokenHolder = function(f, d, l) {
    a.$broadcast(b.WM_UPDATE_JOINNET);
    c.update_holder_sender_video_recv_status();
    a.$broadcast(b.WM_TALKER_STATUS_CHANGED);
  };
  p.jn_callback_NewDataSender = p.jn_callback_NewDataSender = function(f) {
    a.$broadcast(b.WM_UPDATE_JOINNET);
    c.update_holder_sender_video_recv_status();
    a.$broadcast(b.WM_TALKER_STATUS_CHANGED);
  };
  p.jn_callback_ParticipantVideoSpeakerStatus = p.jn_callback_ParticipantVideoSpeakerStatus = function(f, c, d) {
    c ? a.$broadcast(b.WM_NEW_SPEAKER, f) : hmtg.jnkernel.jn_command_ParticipantVideoStop(f);
    a.$broadcast(b.WM_UPDATE_JOINNET);
    a.$broadcast(b.WM_TALKER_STATUS_CHANGED);
  };
  p.jn_callback_LeaveMessage = p.jn_callback_LeaveMessage = function(a, f) {
    d.update_status_item({});
    1 == f ? q.ShowErrorPrompt(function() {
      return k.instant("IDS_CALL_NOT_ACCEPTED");
    }, 20) : q.ShowErrorPrompt(function() {
      return k.instant("IDS_CALL_REJECTED");
    }, 20);
  };
  p.jn_callback_WaitForResponse = p.jn_callback_WaitForResponse = function(a) {
    var f = hmtg.util.decodeUtf8(a), c = {timeout:60, update:function() {
      return k.instant("IDS_WAIT_OWNER_RESPONSE").replace("%1$s", a ? f : k.instant("ID_OWNER"));
    }};
    c.text = c.update();
    c.type = "success";
    d.update_status_item(c);
  };
  p.jn_callback_ServerShutdown = p.jn_callback_ServerShutdown = function() {
    q.ShowErrorPrompt(function() {
      return k.instant("IDS_WEBOFFICE_EX_ERROR_SERVER_SHUTDOWN");
    }, 60);
  };
  p.jn_command_CallbackReady();
  this.connect = function(f) {
    hmtg.util.localStorage.last_jnj = f;
    e.parseJnj(f);
    if (!e.valid_jnj) {
      return!1;
    }
    hmtg.util.log("jnj content:\n" + hmtg.util.decodeUtf8(f));
    if (!p.jn_command_read_jnj(e)) {
      return!1;
    }
    this.resetAutoReconnect();
    a.$broadcast(b.WM_RESET_SESSION);
    d.update_status_item({});
    p.jn_info_GetWebOfficeVisitorTargetID() ? setTimeout(function() {
      hmtg.jnkernel.jn_command_WebOfficeSetVisitorName(k.instant("IDS_GUEST") + hmtg.util.app_id);
      hmtg.jnkernel.jn_command_QuitConnection();
      hmtg.jnkernel.jn_command_initconnectmedia();
    }, 2E3) : (p.jn_command_QuitConnection(), p.jn_command_initconnectmedia());
    return!0;
  };
}]).controller("DurationCtrl", ["$scope", "jnjContent", "hmtgHelper", "playback", function(a, e, d, b) {
  a.duration_str = hmtg.jnkernel._duration_str;
  a.playback_tick_str = function() {
    return b.tick_str;
  };
  a.can_show_badge = function() {
    return hmtg.jnkernel._jn_bConnected() || "undefined" != typeof hmtg.jnkernel._jn_iWorkMode() && (hmtg.jnkernel._jn_bConnecting() || e.valid_jnj);
  };
  a.can_show_mode = function(a) {
    return(hmtg.jnkernel._jn_bConnected() || hmtg.jnkernel._jn_bConnecting() || e.valid_jnj) && hmtg.jnkernel._jn_iWorkMode() == a;
  };
  a.can_show_duration = function() {
    return hmtg.jnkernel._jn_bConnected() && hmtg.jnkernel._jn_iWorkMode() == hmtg.config.NORMAL;
  };
  a.can_show_tick_str = function() {
    return hmtg.jnkernel._jn_bConnected() && hmtg.jnkernel._jn_iWorkMode() == hmtg.config.PLAYBACK;
  };
  a.$on(d.WM_UPDATE_DURATION, function() {
    d.inside_angular || a.$digest();
  });
  a.$on(d.WM_PLAYBACK_UPDATE_TICK_STR, function() {
    d.inside_angular || a.$digest();
  });
  a.$on(d.WM_PLAYBACK_TICK_UPDATE, function(e, k) {
    b.tick_str = b.calc_tick_str(k);
    d.inside_angular || a.$digest();
  });
}]).service("statistics", ["$rootScope", function(a) {
  this.active = !1;
}]);
angular.module("joinnet").service("chat", ["$translate", "appSetting", "hmtgHelper", "hmtgAlert", "$rootScope", function(a, e, d, b, h) {
  var k = this;
  this.data = [];
  this.display_index = 0;
  this.add_chat = function(a, e, b, r, q) {
    a = k.data;
    e = {};
    e.text = hmtg.util.decodeUtf8(r);
    e.class_text = -1 != r.indexOf(">[To:") ? "text-danger" : "";
    a.push(e);
    k.display_index = a.length - 1;
    h.$broadcast(d.WM_UPDATE_CHAT, !0);
  };
  this.reset = function() {
    k.data = [];
    h.$broadcast(d.WM_UPDATE_CHAT);
  };
  this.event_quit_session = function() {
    k.data = [];
    b.clear_chat_alert_item();
    h.$broadcast(d.WM_UPDATE_CHAT);
  };
}]);
angular.module("joinnet").service("playback", ["$translate", "appSetting", "hmtgHelper", "$rootScope", function(a, e, d, b) {
  this.init_stat = function(a, e, g, s) {
    this.ready = !0;
    this.start_tick = a;
    this.end_tick = e;
    this.bandwidth = g;
    this.start_str = s;
    this.tick = a;
    b.$broadcast(d.WM_PLAYBACK_INIT_STAT);
    b.$broadcast(d.WM_PLAYBACK_TICK_UPDATE, this.tick);
  };
  this.event_quit_session = function() {
  };
  this.reset = function() {
    this.end_tick = this.start_tick = 0;
    this.start_str = "";
    this.bandwidth = 0;
    this.random_access = !1;
    this.random_access_tick = 0;
    this.queued_jump = !1;
    this.tick = 0;
    this.tick_str = "";
    this.ready = this.paused = this.repeat = !1;
    b.$broadcast(d.WM_UPDATE_PLAYBACK);
  };
  this.restart = function() {
    this.random_access = !1;
  };
  this.calc_tick = function(a) {
    var d, e, b, m = 1;
    45 == a.charCodeAt(0) && (m = -1, a = a.slice(1));
    var r = a.lastIndexOf(".");
    -1 == r ? b = 0 : (b = parseInt(a.slice(r + 1)), a = a.slice(0, r));
    r = a.lastIndexOf(":");
    if (-1 == r) {
      return(1E3 * parseInt(a) + b) * m;
    }
    e = parseInt(a.slice(r + 1));
    a = a.slice(0, r);
    r = a.lastIndexOf(":");
    if (-1 == r) {
      return(1E3 * (60 * parseInt(a) + e) + b) * m;
    }
    d = parseInt(a.slice(r + 1));
    a = a.slice(0, r);
    return(1E3 * (3600 * parseInt(a) + 60 * d + e) + b) * m;
  };
  this.calc_tick_str = function(a, d) {
    var e = a >>> 0, b = e;
    e & 2147483648 && (b = -e >>> 0);
    var m = b / 1E3 >>> 0, r = b - 1E3 * m, q = m / 60 >>> 0, m = ("0000" + (m - 60 * q)).slice(-2), r = b - 6E4 * q, b = q / 60 >>> 0, q = ("0000" + (q - 60 * b)).slice(-2), e = e & 2147483648 ? ["-", b, ":", q, ":", m].join("") : ["", b, ":", q, ":", m].join("");
    d && (e += "." + ("000000" + r).slice(-3));
    return e;
  };
  this.reset();
}]);
angular.module("joinnet").service("joinnetHelper", ["hmtgAlert", "hmtgHelper", "$rootScope", "$translate", function(a, e, d, b) {
  this.errorcode2id = function(a) {
    switch(a) {
      case hmtg.config.JN_RESOLVE_PROXY:
        return "IDS_RESOLVE_PROXY";
      case hmtg.config.JN_FAIL_CONNECT_GC:
        return "IDS_FAIL_CONNECT_GC";
      case hmtg.config.JN_CONNECT_GC_BROKEN:
        return "IDS_CONNECT_GC_BROKEN";
      case hmtg.config.JN_CONNECTING_MCU:
        return "IDS_CONNECTING_MCU";
      case hmtg.config.JN_FAIL_CONNECT_MCU:
        return "IDS_FAIL_CONNECT_MCU";
      case hmtg.config.JN_NO_SCHEDULE:
        return "IDS_NO_SCHEDULE";
      case hmtg.config.JN_WRONG_IP_PASSWD:
        return "IDS_WRONG_IP_PASSWD";
      case hmtg.config.JN_WRONG_AUTH_PASSWD:
        return "IDS_WRONG_AUTH_PASSWD";
      case hmtg.config.JN_MEETING_NOT_EXIST2:
        return "IDS_MEETING_NOT_EXIST2";
      case hmtg.config.JN_TOOMANY_USER_2:
        return "IDS_TOOMANY_USER_2";
      case hmtg.config.JN_CONNECTION_ESTABLISHED:
        return "IDS_CONNECTION_ESTABLISHED";
      case hmtg.config.JN_QUESTION_CANCEL_DUE_TRANSFER:
        return "IDS_QUESTION_CANCEL_DUE_TRANSFER";
      case hmtg.config.JN_YOU_HAVENOT_TOKEN:
        return "IDS_YOU_HAVENOT_TOKEN";
      case hmtg.config.JN_NEW_USER:
        return "IDS_NEW_USER";
      case hmtg.config.JN_USER_LEAVE:
        return "IDS_USER_LEAVE";
      case hmtg.config.JN_QUESTION_FINISH:
        return "IDS_QUESTION_FINISH";
      case hmtg.config.JN_QUESTION_ACCEPTED:
        return "IDS_QUESTION_ACCEPTED";
      case hmtg.config.JN_QUESTION_IN_QUEUE:
        return "IDS_QUESTION_IN_QUEUE";
      case hmtg.config.JN_QUESTION_SKIPPED:
        return "IDS_QUESTION_SKIPPED";
      case hmtg.config.JN_DISCONNECT_BY_OWNER:
        return "IDS_DISCONNECT_BY_OWNER";
      case hmtg.config.JN_MEETING_OVER:
        return "IDS_MEETING_OVER";
      case hmtg.config.JN_QUESTION_CANCELED:
        return "IDS_QUESTION_CANCELED";
      case hmtg.config.JN_USER_OVERWRITE:
        return "IDS_USER_OVERWRITE";
      case hmtg.config.JN_YOU_HAVE_TOKEN:
        return "IDS_YOU_HAVE_TOKEN";
      case hmtg.config.JN_FILE_READ_ERROR:
        return "IDS_FILE_READ_ERROR";
      case hmtg.config.JN_FILE_PAGE_ERROR:
        return "IDS_FILE_PAGE_ERROR";
      case hmtg.config.JN_NO_MCU:
        return "IDS_NO_MCU";
      case hmtg.config.JN_CONNECT_PROXY_NO_CONNECT_MCU:
        return "IDS_CONNECT_PROXY_NO_CONNECT_MCU";
      case hmtg.config.JN_MCU_TALK_MISMATCH:
        return "IDS_MCU_TALK_MISMATCH";
      case hmtg.config.JN_TESTING_AV:
        return "IDS_TESTING_AV";
      case hmtg.config.JN_FAIL_UDP:
        return "IDS_FAIL_UDP";
      case hmtg.config.JN_CORRUPT_SERVER_PARAMETER:
        return "IDS_JN_CORRUPT_SERVER_PARAMETER";
      case hmtg.config.JN_DELETE_FILE_OK:
        return "IDS_JN_DELETE_FILE_OK";
      case hmtg.config.JN_DELETE_FILE_FAIL:
        return "IDS_JN_DELETE_FILE_FAIL";
      case hmtg.config.JN_JNJ_FILE_READ_ERROR:
        return "IDS_CAN_NOT_READ_JNJ";
      case hmtg.config.JN_JNJ_UNKNOWN_CODE_TYPE:
        return "IDS_UNKNOWN_CODETYPE";
      case hmtg.config.JN_JNR_FILE_ERROR:
        return "IDS_RECORDING_FILE_ERROR";
      case hmtg.config.JN_MEETING_TERMINATED:
        return "IDS_WARNING_MEETING_TERMINATED";
      case hmtg.config.JN_PREPARATION_MODE:
        return "IDS_PREPARATION_MODE";
      case hmtg.config.JN_PREPARATION_SWITCH_TO_NORMAL:
        return "IDS_PREPARATION_SWITCH_TO_NORMAL";
      case hmtg.config.JN_PROXY_ERROR_BASE + hmtg.config.PROXY_ERROR_CONNECT_FAIL:
        return "IDS_FAIL_CONNECT_PROXY";
      case hmtg.config.JN_PROXY_ERROR_BASE + hmtg.config.PROXY_ERROR_CONNECT_BROKEN:
        return "IDS_CONNECT_PROXY_BROKEN";
      case hmtg.config.JN_PROXY_ERROR_BASE + hmtg.config.PROXY_ERROR_NO_AUTH:
        return "IDS_CONNECT_PROXY_NO_AUTH";
      case hmtg.config.JN_PROXY_ERROR_BASE + hmtg.config.PROXY_ERROR_NO_CONNECT:
        return "IDS_CONNECT_PROXY_NO_CONNECT_GC";
      case hmtg.config.JN_PROXY_ERROR_BASE + hmtg.config.PROXY_ERROR_NO_UDP_ASSOCIATION:
        return "IDS_CONNECT_PROXY_NO_UDP_ASSOCIATION";
      case hmtg.config.JN_PROXY_ERROR_BASE + hmtg.config.PROXY_ERROR_NOT_SOCKS5:
        return "IDS_CONNECT_PROXY_NOT_SOCKS5";
      case hmtg.config.JN_PROXY_ERROR_BASE + hmtg.config.PROXY_ERROR_HTTPS_FAIL:
        return "IDS_ERROR_PROXY_HTTPS_FAILED";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_WRONG_USERID:
        return "IDS_NO_USERID";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_WRONG_PASSWD:
        return "IDS_WRONG_PASSWD";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_ALREADY_LOGGED:
        return "IDS_ALREADY_LOGGED";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_PARAMETER:
        return "IDS_ILLEGAL_PARAM";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_SESSIONID:
        return "IDS_WRONG_SESSIONID";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_MEETING_NOT_EXIST:
        return "IDS_MEETING_NOT_EXIST";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_INTERNAL:
        return "IDS_INTERNAL_ERROR";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_FILE_ERROR:
        return "IDS_FILE_ERROR";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_TOOMANY_PLAYBACK:
        return "IDS_TOOMANY_PLAYBACK";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_ILLEGAL_FILE:
        return "IDS_ILLEGAL_FILE";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_WRONG_PASSWD2:
        return "IDS_WRONG_PASSWD2";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_TOOMANY_DOWNLOAD:
        return "IDS_TOOMANY_DOWNLOAD";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_TOOMANY_USER:
        return "IDS_TOOMANY_USER";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_CALL_REJECTED:
        return "IDS_CALL_REJECTED";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_CALL_NOT_ACCEPTED:
        return "IDS_CALL_NOT_ACCEPTED";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_JOINNETMODE:
        return "IDS_WRONG_JOINNET_MODE";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_SESSION_CLOSED:
        return "IDS_SESSION_CLOSED";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_TOO_MANY_SESSION:
        return "IDS_SERVER_BUSY";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_CAN_NOT_RECORD:
        return "IDS_CAN_NOT_RECORD";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_MESSAGE_NOT_EXIST:
        return "IDS_MESSAGE_NOT_EXIST";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_LINE_BUSY:
        return "IDS_LINE_BUSY";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_EXCEED_DISK_QUOTA:
        return "IDS_ERROR_EXCEED_DISK_QUOTA";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_WRONG_USERINFO2:
        return "IDS_ERROR_WRONG_USERINFO2";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_OWNER_IN_PREPARATION_MODE:
        return "IDS_ERROR_OWNER_IN_PREPARATION_MODE";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_PREPARATION_MODE_TOO_LATE:
        return "IDS_ERROR_PREPARATION_MODE_TOO_LATE";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_ILLEGAL_REQUEST:
        return "IDS_ERROR_ILLEGAL_REQUEST";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_OUT_OF_MEMORY:
        return "IDS_ERROR_MCU_OUT_OF_MEMORY";
      case hmtg.config.JN_MCU_RELAY_BASE + hmtg.config.MRP_ERROR_CONTINUE:
        return "IDS_MCU_RELAY_ERROR_CONTINUE";
      case hmtg.config.JN_MCU_RELAY_BASE + hmtg.config.MRP_ERROR_SLIDENOTREADY:
        return "IDS_MCU_RELAY_ERROR_SLIDENOTREADY";
      case hmtg.config.JN_EARLY_DISCONNECTION_1:
        return "IDS_PROXY_FAIL_CONNECT_MCU";
      case hmtg.config.JN_EARLY_DISCONNECTION_2:
        return "IDS_CONNECTION_REFUSED";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_INVALID_LICENSE:
        return "IDS_ERROR_INVALID_LICENSE";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_REQUEST_REJECTED:
        return "IDS_ERROR_REQUEST_REJECTED";
      case hmtg.config.JN_ERROR_BASE - 256 + hmtg.config.ERROR_VERSION:
        return "IDS_WRONG_VERSION";
      case hmtg.config.JN_UNKNOWN_ERROR:
        return "IDS_UNKNOWN_ERROR";
      default:
        return "IDS_UNKNOWN_ERROR(" + a + ")";
    }
  };
}]);
angular.module("joinnet").service("audio_playback", ["$translate", "appSetting", "hmtgHelper", "hmtgAlert", "$rootScope", "hmtgSound", function(a, e, d, b, h, k) {
  var g = this, s = k.ac, m = s ? s.sampleRate : 8E3, r = Math.max(k.playback_buffer_size << 1, m >> 1);
  this.audio_playback_array = {};
  this.prev_opus = {};
  this.event_quit_session = function() {
    for (var a in this.audio_playback_array) {
      if (this.audio_playback_array[a]) {
        this.audio_playback_array[a].decoded_audio_data = [];
        this.audio_playback_array[a].played_size = 0;
        this.audio_playback_array[a].total_size = 0;
        this.audio_playback_array[a].playback_node.onaudioprocess = null;
        this.audio_playback_array[a].playback_node.disconnect();
        this.audio_playback_array[a].playback_node = null;
        this.audio_playback_array[a].g711_decoder && (this.audio_playback_array[a].g711_decoder.onmessage = null, this.audio_playback_array[a].g711_decoder.postMessage({command:"exit"}), this.audio_playback_array[a].g711_decoder = null);
        this.audio_playback_array[a].opus_decoder && (this.audio_playback_array[a].opus_decoder.onmessage = null, this.audio_playback_array[a].opus_decoder.postMessage({command:"exit"}), this.audio_playback_array[a].opus_decoder = null);
        var d;
        for (d = 0;0 > d;d++) {
          this.audio_playback_array[a].opus_decoder_array[d] && (this.audio_playback_array[a].opus_decoder_array[d].onmessage = null, this.audio_playback_array[a].opus_decoder_array[d].postMessage({command:"exit"}), this.audio_playback_array[a].opus_decoder_array[d] = null);
        }
        this.audio_playback_array[a] = null;
      }
    }
    this.audio_playback_array = {};
    this.prev_opus = {};
  };
  this.recv_audio = function(a, l, f) {
    if (s) {
      if (!this.audio_playback_array[f]) {
        var c;
        c = k.playback_buffer_size;
        c = s.createScriptProcessor ? s.createScriptProcessor(c, 0, 1) : s.createJavaScriptNode(c, 0, 1);
        this.audio_playback_array[f] = {};
        this.audio_playback_array[f].playback_node = c;
        this.audio_playback_array[f].decoded_audio_data = [];
        this.audio_playback_array[f].played_size = 0;
        this.audio_playback_array[f].total_size = 0;
        this.audio_playback_array[f].type = 0;
        this.audio_playback_array[f].opus_decoder_array = [];
        c.onaudioprocess = function(a) {
          a = a.outputBuffer.getChannelData(0);
          var c = 0;
          if (g.audio_playback_array[f]) {
            var d = g.audio_playback_array[f].decoded_audio_data, e = g.audio_playback_array[f].played_size, l = g.audio_playback_array[f].total_size;
            if (l > r) {
              for (;l > 2 * r;) {
                l -= d[0].length - e, e = 0, d.splice(0, 1);
              }
              for (;l > r && !(Math.random() >= l / r - 1);) {
                l -= d[0].length - e, e = 0, d.splice(0, 1);
              }
            }
            for (;d.length;) {
              var b = a.length - c;
              if (d[0].length - e > b) {
                a.set(d[0].subarray(e, e + b), c);
                c += b;
                l -= b;
                e += b;
                break;
              }
              if (d[0].length - e == b) {
                a.set(d[0].subarray(e), c);
                c += b;
                l -= b;
                e = 0;
                d.splice(0, 1);
                break;
              } else {
                a.set(d[0].subarray(e), c), c += d[0].length - e, l -= d[0].length - e, e = 0, d.splice(0, 1);
              }
            }
            for (;c < a.length;c++) {
              a[c] = 0;
            }
            g.audio_playback_array[f].played_size = e;
            g.audio_playback_array[f].total_size = l;
          } else {
            for (;c < a.length;c++) {
              a[c] = 0;
            }
          }
        };
        c.connect(k.create_playback_gain_node());
      }
      c = this.audio_playback_array[f].type;
      this.audio_playback_array[f].type = l;
      c != l && e.restrict_audio_decoding && h.$broadcast(d.WM_UPDATE_AUDIO_DECODING);
      c = a.charCodeAt(0);
      switch(l) {
        case hmtg.config.AUDIO_G711:
          0 == c ? this.g711_decode(hmtg.config.MEDIA_AUDIO_G711_50MS, a, f) : 1 == c ? this.g711_decode(hmtg.config.MEDIA_AUDIO_G711_20MS, a, f) : 2 == c && this.g711_decode(hmtg.config.MEDIA_AUDIO_G711_11K_89K_40MS, a, f);
          break;
        case hmtg.config.AUDIO_G726_11:
          2 == c && this.g711_decode(hmtg.config.MEDIA_AUDIO_G711_11K_89K_40MS, a, f);
          break;
        case hmtg.config.AUDIO_OPUS:
          0 == c ? (this.opus_decode(a, f), this.prev_opus[f] = this.prev_opus[f] || {}, this.prev_opus[f].data = null) : (l = (a.charCodeAt(2) & 15) << 8 | a.charCodeAt(3), this.prev_opus[f] && this.prev_opus[f].data ? 1 == l - this.prev_opus[f].seq ? (this.opus_decode2(this.prev_opus[f].data, a, f), this.prev_opus[f].data = null) : l & 1 ? (this.opus_decode2(null, a, f), this.prev_opus[f].data = null) : (this.prev_opus[f].data = a, this.prev_opus[f].seq = l) : l & 1 || (this.prev_opus[f] = this.prev_opus[f] || 
          {}, this.prev_opus[f].data = a, this.prev_opus[f].seq = l));
      }
    }
  };
  this.g711_decode = function(a, e, f) {
    if (!g.audio_playback_array[f].g711_decoder) {
      try {
        g.audio_playback_array[f].g711_decoder = new Worker("worker/g711_decode.js"), g.audio_playback_array[f].g711_decoder.addEventListener("error", window.onerrorWorker, !1), g.audio_playback_array[f].g711_decoder.postMessage({command:"init", sampleRate:m, good_worker:d.good_worker});
      } catch (c) {
        hmtg.jnkernel.jn_command_UnknownMedia(hmtg.config.AUDIO_G711, f);
        return;
      }
      g.audio_playback_array[f].g711_decoder.onmessage = function(a) {
        switch(a.data.command) {
          case "data_out":
            g.audio_playback_array[f].decoded_audio_data.push(a.data.data), g.audio_playback_array[f].total_size += a.data.data.length;
        }
      };
    }
    for (var b = new Uint8Array(e.length - 1), p = 0;p < b.length;++p) {
      b[p] = e.charCodeAt(p + 1);
    }
    d.good_worker ? g.audio_playback_array[f].g711_decoder.postMessage({command:"data_in", media_type:a, data:b}, [b.buffer]) : g.audio_playback_array[f].g711_decoder.postMessage({command:"data_in", media_type:a, data:b});
  };
  this.check_opus_decoder = function(a) {
    if (!g.audio_playback_array[a].opus_decoder) {
      try {
        g.audio_playback_array[a].opus_decoder_error = !1;
        g.audio_playback_array[a].opus_decoder = new Worker("worker/opus_decode.js");
        g.audio_playback_array[a].opus_decoder.addEventListener("error", window.onerrorWorker, !1);
        g.audio_playback_array[a].opus_decoder.postMessage({command:"init", sampleRate:m, good_worker:d.good_worker});
        var e;
        for (e = 0;0 > e;e++) {
          g.audio_playback_array[a].opus_decoder_array[e] = new Worker("worker/opus_decode.js"), g.audio_playback_array[a].opus_decoder_array[e].postMessage({command:"init", sampleRate:m, good_worker:d.good_worker});
        }
      } catch (f) {
        hmtg.jnkernel.jn_command_UnknownMedia(hmtg.config.AUDIO_OPUS, a);
        return;
      }
      g.audio_playback_array[a].opus_decoder.onmessage = function(f) {
        switch(f.data.command) {
          case "data_out":
            g.audio_playback_array[a].decoded_audio_data.push(f.data.data);
            g.audio_playback_array[a].total_size += f.data.data.length;
            break;
          case "log":
            hmtg.util.log("opus_decoder: " + f.data.line);
            break;
          case "error":
            g.audio_playback_array[a].opus_decoder_error = !0, hmtg.jnkernel.jn_command_UnknownMedia(hmtg.config.AUDIO_OPUS, a);
        }
      };
    }
  };
  this.opus_decode = function(a, e) {
    g.check_opus_decoder(e);
    if (!g.audio_playback_array[e].opus_decoder_error) {
      for (var f = new Uint8Array(a.length - 4), c = 0;c < f.length;++c) {
        f[c] = a.charCodeAt(c + 4);
      }
      for (c = 0;0 > c;c++) {
        g.audio_playback_array[e].opus_decoder_array[c].postMessage({command:"data_in", data:f});
      }
      d.good_worker ? g.audio_playback_array[e].opus_decoder.postMessage({command:"data_in", data:f}, [f.buffer]) : g.audio_playback_array[e].opus_decoder.postMessage({command:"data_in", data:f});
    }
  };
  this.opus_decode2 = function(a, e, f) {
    g.check_opus_decoder(f);
    if (!g.audio_playback_array[f].opus_decoder_error) {
      var c;
      if (a) {
        c = new Uint8Array(a.length - 4);
        for (var b = 0;b < c.length;++b) {
          c[b] = a.charCodeAt(b + 4);
        }
      } else {
        c = new Uint8Array(0);
      }
      if (a) {
        for (a = new Uint8Array(a.length - 4), b = 0;b < a.length;++b) {
          a[b] = e.charCodeAt(b + 4);
        }
      } else {
        a = new Uint8Array(0);
      }
      for (b = 0;0 > b;b++) {
        g.audio_playback_array[f].opus_decoder_array[b].postMessage({command:"data_in2", data0:c, data1:a});
      }
      d.good_worker ? g.audio_playback_array[f].opus_decoder.postMessage({command:"data_in2", data0:c, data1:a}, [c.buffer, a.buffer]) : g.audio_playback_array[f].opus_decoder.postMessage({command:"data_in2", data0:c, data1:a});
    }
  };
}]);
angular.module("joinnet").service("video_recving", ["$translate", "appSetting", "hmtgHelper", "hmtgAlert", "$rootScope", "hmtgSound", function(a, e, d, b, h, k) {
  this.is_recv_video = e.auto_recv_video;
  this.ssrc_array = [0];
  this.ssrc_hash = {};
  this.is_selected_video_ssrc = function(a) {
    return 0 != a ? !1 : !0;
  };
  this.update_holder_sender_video_recv_status = function() {
    var a = hmtg.jnkernel._jn_iTokenHolder(), d = hmtg.jnkernel._jn_iDataSender(), e = this.is_selected_video_ssrc(d), b = this.is_selected_video_ssrc(a);
    e || b ? (this.is_recv_video && hmtg.jnkernel.jn_command_RequestVideo(!0), -1 != d && d != a && (e && b ? hmtg.jnkernel.jn_command_UpdateBothVideoPreference(!0) : (hmtg.jnkernel.jn_command_UpdateBothVideoPreference(!1), hmtg.jnkernel.jn_command_UpdatePreference(e)))) : hmtg.jnkernel.jn_command_RequestVideo(!1);
  };
  this.reset_video = function(a) {
    (a = this.ssrc_hash[a]) && a.canvas && (a.canvas.width = a.canvas.height = 0, a.has_img = !1);
  };
  this.draw_video = function(a, e) {
    var b = this.ssrc_hash[e];
    b || (b = this.ssrc_hash[e] = {});
    if (!b.canvas) {
      b.canvas = document.getElementById("video-" + e);
      if (!b.canvas) {
        return;
      }
      b.ctx = b.canvas.getContext("2d");
      b.has_img = !1;
    }
    var h = a.video_playback_array[e];
    if (h && h.canvas && h.canvas.width) {
      var k = h.canvas.width, l = h.canvas.height;
      b.has_img = !0;
      var f, c;
      if (b.is_fullscreen) {
        f = d.view_port_width, c = f * l / k >> 0, c > d.view_port_height && (c = d.view_port_height, f = c * k / l >> 0);
      } else {
        f = Math.max(80, d.view_port_width - 60);
        var t = Math.max(80, d.view_port_height - 120);
        c = f * l / k >> 0;
        c > t && (c = t, f = c * k / l >> 0);
      }
      20 > f && (f = 20);
      20 > c && (c = 20);
      if (b.canvas.width != f || b.canvas.height != c) {
        b.canvas.width = f, b.canvas.height = c;
      }
      b.ctx.clearRect(0, 0, b.canvas.width, b.canvas.height);
      b.ctx.drawImage(h.canvas, 0, 0, h.canvas.width, h.canvas.height, 0, 0, f, c);
    } else {
      b.canvas.width = b.canvas.height = 0, b.has_img = !1;
    }
  };
}]).service("video_playback", ["$translate", "appSetting", "hmtgHelper", "hmtgAlert", "$rootScope", "hmtgSound", "video_recving", function(a, e, d, b, h, k, g) {
  function s() {
    function a(f) {
      var c = q.video_playback_array[f];
      c || (c = q.video_playback_array[f] = {}, q.init_video_playback(c));
      f = hmtg.jnkernel._jn_UserArray()[f]._m_spic_img();
      if (!c.canvas.width || !c.is_video_canvas && !f || c.is_video_canvas && d - c.tick > hmtg.config.SHOW_MYPICTURE_DELAY) {
        if (f) {
          if (c.w != f.width || c.h != f.height) {
            c.w = f.width, c.h = f.height, c.canvas.width = c.w, c.canvas.height = c.h;
          }
          try {
            c.ctx.drawImage(f, 0, 0);
          } catch (e) {
            return f = c.canvas.width, c.w = 0, c.canvas.width = c.canvas.height = 0, c.is_video_canvas = !1, !!f;
          }
          c.is_video_canvas = !1;
          return c.canvas;
        }
        if (c.canvas.width) {
          return c.w = 0, c.canvas.width = c.canvas.height = 0, c.is_video_canvas = !1, !0;
        }
      }
      if (c.canvas.width) {
        return c.canvas;
      }
    }
    if (hmtg.jnkernel._jn_bConnected()) {
      var c, d = hmtg.util.GetTickCount(), e, b = hmtg.jnkernel._jn_UserArray();
      for (e = 0;e < g.ssrc_array.length;e++) {
        c = g.ssrc_array[e], b[c] && a(c) && g.draw_video(q, c);
      }
    }
  }
  function m(a, c) {
    for (;60 < a.length || 1 < a.length && 2E3 < a[a.length - 1].ts - a[0].ts;) {
      a.splice(0, 1);
    }
  }
  function r(a) {
    a = a.queue;
    if (a.length) {
      var c = a[0];
      a.splice(0, 1);
      switch(c.type) {
        case hmtg.config.VIDEO_H264:
        ;
        case hmtg.config.VIDEO_F264:
          q.h264_decode(c.data, c.type, c.ssrc);
          break;
        case hmtg.config.VIDEO_MJPG:
          q.mjpg_decode(c.data, c.ssrc);
      }
    }
  }
  var q = this;
  this.video_playback_array = {};
  this.remove_alert_item = function() {
    this.alert_item && (b.remove_link_item(this.alert_item), this.alert_item = null);
  };
  this.net_init_finished = function() {
    hmtg.jnkernel._jn_iWorkMode() == hmtg.config.PLAYBACK && (g.is_recv_video || (g.is_recv_video = !g.is_recv_video, this.stop_recv_video()), e.prefer_questioner || hmtg.jnkernel.jn_command_UpdatePreference(!1));
    h.$broadcast(d.WM_UPDATE_JOINNET);
  };
  this.event_quit_session = function() {
    for (var a in this.video_playback_array) {
      this.video_playback_array[a] && (this.video_playback_array[a].quit_flag = !0, this.video_playback_array[a].h264_decoder && (this.video_playback_array[a].h264_decoder.onmessage = null, this.video_playback_array[a].h264_decoder.postMessage({command:"exit"}), this.video_playback_array[a].h264_decoder = null), this.video_playback_array[a] = null);
      var c = g.ssrc_hash[a];
      c && c.canvas && (c.canvas.width = c.canvas.height = 0, c.has_img = !1);
    }
    this.video_playback_array = {};
    this.remove_alert_item();
  };
  this.restart = function() {
    if (g.is_recv_video) {
      g.update_holder_sender_video_recv_status();
      var a = hmtg.jnkernel._jn_iParticipantAudioSsrc(), c;
      for (c = 0;c < a.length;c++) {
        -1 != a[c] && g.is_selected_video_ssrc(a[c]) && hmtg.jnkernel.jn_command_ParticipantVideoRequest(a[c]);
      }
    } else {
      for (hmtg.jnkernel.jn_command_RequestVideo(!1), a = hmtg.jnkernel._jn_iParticipantAudioSsrc(), c = 0;c < a.length;c++) {
        -1 != a[c] && hmtg.jnkernel.jn_command_ParticipantVideoStop(a[c]);
      }
    }
    e.prefer_questioner || hmtg.jnkernel.jn_command_UpdatePreference(!1);
  };
  this.turnon_mypicture_interval = function() {
    q.mypicture_intervalID || (q.mypicture_intervalID = setInterval(s, 1E3));
  };
  this.turnoff_mypicture_interval = function() {
    q.mypicture_intervalID && (clearInterval(q.mypicture_intervalID), q.mypicture_intervalID = null);
  };
  this.add_user = function(a) {
    var c = q.video_playback_array[a];
    c && (c.w = 0, c.canvas.width = c.canvas.height = 0, c.is_video_canvas = !1);
    g.reset_video(a);
  };
  this.start_recv_video = function() {
    this.remove_alert_item();
    if (!g.is_recv_video && (g.is_recv_video = !0, hmtg.jnkernel._jn_bConnected())) {
      g.update_holder_sender_video_recv_status();
      var a = hmtg.jnkernel._jn_iParticipantAudioSsrc(), c;
      for (c = 0;c < a.length;c++) {
        -1 != a[c] && g.is_selected_video_ssrc(a[c]) && hmtg.jnkernel.jn_command_ParticipantVideoRequest(a[c]);
      }
    }
  };
  this.stop_recv_video = function() {
    this.remove_alert_item();
    if (g.is_recv_video && (g.is_recv_video = !1, hmtg.jnkernel._jn_bConnected())) {
      hmtg.jnkernel.jn_command_RequestVideo(!1);
      var a = hmtg.jnkernel._jn_iParticipantAudioSsrc(), c;
      for (c = 0;c < a.length;c++) {
        -1 != a[c] && hmtg.jnkernel.jn_command_ParticipantVideoStop(a[c]);
      }
    }
  };
  this.draw_video = function(a, c) {
    var d = hmtg.util.GetTickCount();
    a.tick = d;
    a.is_video_canvas = !0;
    g.draw_video(q, c);
  };
  this.init_video_playback = function(a) {
    a.canvas = document.createElement("canvas");
    a.ctx = a.canvas.getContext("2d");
    a.w = 0;
    a.h = 0;
    a.canvas.width = a.w;
    a.canvas.height = a.h;
    a.queue = [];
    a.busy = !1;
    a.tick = hmtg.util.GetTickCount() - 6E4;
    a.is_video_canvas = !1;
  };
  this.recv_video = function(a, c, d, e, b) {
    if (g.is_selected_video_ssrc(d)) {
      var l = this.video_playback_array[d];
      l || (l = this.video_playback_array[d] = {}, this.init_video_playback(l));
      var h = l.queue;
      h.push({data:a, type:c, ssrc:d, ts:e, ts2:b});
      m(h, d);
      l.busy || r(l);
    }
  };
  var l = hmtg.util.GetTickCount();
  this.h264_decode = function(a, c, e) {
    var b = q.video_playback_array[e];
    if (!b.h264_decoder) {
      try {
        b.h264_decoder = new Worker("worker/h264_decode.js"), b.h264_decoder.addEventListener("error", window.onerrorWorker, !1), b.h264_decoder.postMessage({command:"init", good_worker:d.good_worker});
      } catch (h) {
        hmtg.jnkernel.jn_command_UnknownMedia(c, e);
        setTimeout(function() {
          m(b.queue, e);
          r(b);
        }, 0);
        return;
      }
      b.h264_decoder.onmessage = function(a) {
        switch(a.data.command) {
          case "data_out":
            if (b.quit_flag) {
              break;
            }
            l = hmtg.util.GetTickCount() - l;
            if (b.w != a.data.width || b.h != a.data.height) {
              b.w = a.data.width, b.h = a.data.height, b.canvas.width = b.w, b.canvas.height = b.h, b.idata = b.ctx.createImageData(b.w, b.h);
            }
            b.idata.data.set(a.data.data);
            b.ctx.putImageData(b.idata, 0, 0);
            q.draw_video(b, e);
          case "data_error":
            if (b.quit_flag) {
              break;
            }
            b.busy = !1;
            m(b.queue, e);
            r(b);
        }
      };
    }
    b.busy = !0;
    l = hmtg.util.GetTickCount();
    c = new Uint8Array(a.length - 1);
    for (var g = 0;g < c.length;++g) {
      c[g] = a.charCodeAt(g);
    }
    d.good_worker ? b.h264_decoder.postMessage({command:"data_in", data:c}, [c.buffer]) : b.h264_decoder.postMessage({command:"data_in", data:c});
  };
  this.mjpg_decode = function(a, c) {
    var b = q.video_playback_array[c];
    b.busy = !0;
    for (var d = new Uint8Array(a.length), e = 0;e < d.length;++e) {
      d[e] = a.charCodeAt(e);
    }
    var l, h;
    try {
      l = new Blob([d], {type:"image/jpeg"}), h = window.URL.createObjectURL(l);
    } catch (g) {
      if (b.quit_flag) {
        return;
      }
      b.busy = !1;
      m(b.queue, c);
      r(b);
      return;
    }
    var k = new Image;
    k.addEventListener("load", function() {
      window.URL.revokeObjectURL(h);
      if (!b.quit_flag) {
        if (b.w != k.width || b.h != k.height) {
          b.w = k.width, b.h = k.height, b.canvas.width = b.w, b.canvas.height = b.h;
        }
        try {
          b.ctx.drawImage(k, 0, 0);
        } catch (a) {
        }
        q.draw_video(b, c);
        b.busy = !1;
        m(b.queue, c);
        r(b);
      }
    }, !1);
    k.addEventListener("error", function() {
      window.URL.revokeObjectURL(h);
      b.quit_flag || (b.busy = !1, m(b.queue, c), r(b));
    }, !1);
    k.src = h;
  };
}]);
angular.module("joinnet").controller("VideoWindowCtrl", ["$scope", "hmtgHelper", "JoinNet", "appSetting", "video_recving", "video_playback", "$rootScope", "chat", function(a, e, d, b, h, k, g, s) {
  function m() {
    r(0);
    e.inside_angular || a.$digest();
  }
  function r(a) {
    var b = hmtg.jnkernel._jn_iTokenHolder(), c = hmtg.jnkernel._jn_iDataSender();
    a == b || a == c ? h.update_holder_sender_video_recv_status() : hmtg.jnkernel.is_speaker(a) && hmtg.jnkernel.jn_command_ParticipantVideoRequest(a);
  }
  a.w = {};
  a.as = b;
  a.vr = h;
  a.count = b.max_display_item >> 0;
  a.name_hash = {};
  a.show_list = !0;
  a.show_name = !0;
  a.MAX_VIDEO_ITEM = 100;
  a.container = document.getElementById("video_container");
  a.count = 3;
  a.chat = s;
  a.$on(e.WM_NET_INIT_FINISH, function() {
    r(0);
    k.turnon_mypicture_interval && k.turnon_mypicture_interval();
    e.inside_angular || a.$digest();
  });
  a.$on(e.WM_ADD_USER, function(b, f) {
    var c = hmtg.jnkernel._jn_UserArray(), c = hmtg.util.decodeUtf8(c[f]._szRealName());
    a.name_hash["" + f] = c;
    e.inside_angular || a.$digest();
  });
  a.$on(e.WM_TALKER_STATUS_CHANGED, m);
  a.$on(e.WM_NEW_SPEAKER, function(a, b) {
    -1 != h.ssrc_array.indexOf(b) && hmtg.jnkernel.jn_command_ParticipantVideoRequest(b);
  });
  a.$on(e.WM_QUIT_SESSION, function() {
    e.inside_angular || a.$digest();
  });
  a.$on(e.WM_RESET_SESSION, function() {
    h.ssrc_array = [0];
    a.name_hash = {};
    e.inside_angular || a.$digest();
  });
  a.$on(e.WM_PLAYBACK_RESTART, function() {
    e.inside_angular || a.$digest();
  });
  a.canvas_id = function(a) {
    return "video-" + a;
  };
  a.container_id = function(a) {
    return "container-" + a;
  };
  a.toggle_show_chat = function() {
    a.show_chat = !a.show_chat;
  };
  a.$on(e.WM_UPDATE_CHAT, function(b, f) {
    a.show_chat = !0;
    e.inside_angular || a.$digest();
  });
  a.turnoff_fullscreen = function() {
    e.exitFullScreen();
  };
  a.w.is_fullscreen = !1;
  a.request_fullscreen = a.w.request_fullscreen = a.container.requestFullscreen || a.container.msRequestFullscreen || a.container.mozRequestFullScreen || a.container.webkitRequestFullscreen;
  a.w.fullscreen1 = function() {
    a.w.request_fullscreen && (e.inside_angular++, a.w.request_fullscreen.call(a.container), e.inside_angular--, a.w.is_fullscreen = (document.fullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement || document.msFullscreenElement) == a.container);
  };
  a.w.fullscreen0 = function() {
    e.inside_angular++;
    e.exitFullScreen();
    e.inside_angular--;
    a.w.is_fullscreen = !1;
  };
  a.is_fullscreen = function(a) {
    return!1;
  };
  a.fullscreen1 = function(a) {
    var b = document.getElementById("container-" + a);
    if (b) {
      var c = b.requestFullscreen || b.msRequestFullscreen || b.mozRequestFullScreen || b.webkitRequestFullscreen;
      c && (e.inside_angular++, c.call(b), e.inside_angular--, c = document.fullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement || document.msFullscreenElement, h.ssrc_hash[a] && (h.ssrc_hash[a].is_fullscreen = c == b), h.draw_video(k, a));
    }
  };
  a.fullscreen0 = function(a) {
    e.inside_angular++;
    e.exitFullScreen();
    e.inside_angular--;
    h.ssrc_hash[a] && (h.ssrc_hash[a].is_fullscreen = !1);
    h.draw_video(k, a);
  };
  a.$on(e.WM_FULLSCREEN_CHANGED, function() {
    var b = document.fullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement || document.msFullscreenElement, d = h.ssrc_hash, c;
    for (c in d) {
      if (d.hasOwnProperty(c)) {
        var g = document.getElementById("container-" + c), p = d[c].is_fullscreen;
        d[c].is_fullscreen = g && b == g;
        p != d[c].is_fullscreen && h.draw_video(k, c);
      }
    }
    a.w.is_fullscreen = b == a.container;
    e.inside_angular || a.$digest();
  });
  a.can_disconnect = function() {
    return hmtg.jnkernel._jn_bConnected() || hmtg.jnkernel._jn_bConnecting();
  };
  a.disconnect = function() {
    e.inside_angular++;
    d.resetAutoReconnect();
    e.inside_angular--;
    a.can_disconnect() && (e.inside_angular++, hmtg.jnkernel.jn_command_QuitConnection(), e.inside_angular--);
  };
  b = hmtg.jnkernel._jn_UserArray();
  for (var q in b) {
    b.hasOwnProperty(q) && (g = hmtg.util.decodeUtf8(b[q]._szRealName()), a.name_hash["" + q] = g);
  }
  e.inside_angular++;
  m();
  e.inside_angular--;
}]);
hmtg.config.APP_VERSION = "0.9.0 development built on 04/27/2015";
document.getElementById("error_button1").onclick = function() {
  var a = document.getElementById("error_text");
  if (a) {
    var e = hmtg.util.error_array;
    if (e.length) {
      var d = "", b;
      for (b = 0;b < e.length;b++) {
        var h = e[b].time.toString().replace(/(GMT.*)/, ""), d = d + ("#" + (b + 1) + ", " + h + " " + e[b].text + "\n")
      }
      d += "\n------------------------------\nTotal Error: " + e.length + "\n";
      d += (new Date).toString().replace(/(GMT.*)/, "") + "\n";
      d += "appid=" + hmtg.util.app_id + "\n";
      d += "Browser Information: " + navigator.userAgent + "\n";
      hmtg.jnkernel && hmtg.jnkernel.version && (d += "hmtg jnkernel version " + hmtg.jnkernel.version() + "\n");
      hmtg.jmkernel && hmtg.jmkernel.version && (d += "hmtg jmkernel version " + hmtg.jmkernel.version() + "\n");
      d += "hmtg Web App version " + hmtg.config.APP_VERSION + "\n";
      a.textContent = d;
      a.style.display = "";
      hmtg.util.selectText(a);
      document.getElementById("error_button1").style.display = "none";
      document.getElementById("error_button2").style.display = "";
    }
  }
};
document.getElementById("error_button2").onclick = function() {
  var a = document.getElementById("error_text");
  a && (a.style.display = "none", document.getElementById("error_button2").style.display = "none", document.getElementById("error_button1").style.display = "");
};
document.getElementById("log_button1").onclick = function() {
  var a = document.getElementById("log_text");
  a && (a.textContent = hmtg.util.localStorage.hmtg_log, a.style.display = "", hmtg.util.selectText(a), document.getElementById("log_button1").style.display = "none", document.getElementById("log_button2").style.display = "");
};
document.getElementById("log_button2").onclick = function() {
  var a = document.getElementById("log_text");
  a && (a.style.display = "none", document.getElementById("log_button2").style.display = "none", document.getElementById("log_button1").style.display = "");
};
hmtg.util.log("hmtg Web App version " + hmtg.config.APP_VERSION);
angular.module("hmtgs", ["pascalprecht.translate", "ui.bootstrap", "oc.lazyLoad", "joinnet"]).service("appVersion", [function() {
  this.major = 0;
  this.minor = 9;
  this.full = hmtg.config.APP_VERSION;
}]).factory("$exceptionHandler", function() {
  return function(a, e) {
    console.error(a.stack);
    setTimeout(function() {
      throw a;
    }, 0);
  };
}).config(["$compileProvider", function(a) {
  a.imgSrcSanitizationWhitelist();
  a.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file|blob):|data:image\//);
  a.aHrefSanitizationWhitelist();
  a.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|data|blob):/);
}]).config(["$translateProvider", function(a) {
  a.useStaticFilesLoader({prefix:"lang/translation-", suffix:".json"});
  var e = ["en", "zh_CN", "zh_TW", "ja", "ko"];
  if ("undefined" === typeof hmtg.util.localStorage.hmtg_lang) {
    a.registerAvailableLanguageKeys(e), a.determinePreferredLanguage();
  } else {
    var d = hmtg.util.localStorage.hmtg_lang;
    -1 == e.indexOf(d) ? a.preferredLanguage(e[0]) : a.preferredLanguage(d);
  }
  a.fallbackLanguage("en");
}]).config(["$ocLazyLoadProvider", function(a) {
  a.config({});
}]).run(["$log", "jnjContent", "appVersion", "JoinNet", "$rootScope", "hmtgAlert", "hmtgHelper", "$translate", "hmtgSound", "appSetting", function(a, e, d, b, h, k, g, s, m, r) {
  function q() {
    document.getElementById("error_button1").textContent = s.instant("ID_SHOW_ERROR_REPORT");
    document.getElementById("error_button2").textContent = s.instant("ID_HIDE_ERROR_REPORT");
    document.getElementById("log_button1").textContent = s.instant("ID_SHOW_LOG");
    document.getElementById("log_button2").textContent = s.instant("ID_HIDE_LOG");
  }
  function l() {
    h.$broadcast(g.WM_FULLSCREEN_CHANGED);
  }
  hmtg.util.log("sound support:" + (m.can_mp3 ? " mp3" : "") + (m.can_ogg ? " ogg" : "") + (m.can_wav ? " wav" : ""));
  m.ac ? hmtg.util.log("HTML5 Audio support: " + m.typeAudioContext + ", sampleRate=" + m.ac.sampleRate) : hmtg.util.log("HTML5 Audio support: " + m.typeAudioContext);
  hmtg.util.log("HTML5 URL support: " + m.typeURL);
  hmtg.util.log("HTML5 getUserMedia support: " + m.typeGUM);
  h.turnOnAudio = function() {
    m.turnOnAudio();
  };
  q();
  h.$on("$translateChangeEnd", q);
  h.scroll_to_top = function(a) {
    hmtg.util.scroll_to_top(a);
  };
  h.scroll_to_bottom = function(a) {
    hmtg.util.scroll_to_bottom(a);
  };
  window.addEventListener("dragover", function(a) {
    a.stopPropagation();
    a.preventDefault();
    a.dataTransfer.dropEffect = "none";
  }, !1);
  window.addEventListener("drop", function(a) {
    a.stopPropagation();
    a.preventDefault();
  }, !1);
  window.onbeforeunload = function(a) {
    if (hmtg.jnkernel._jn_bConnecting() || hmtg.jnkernel._jn_bConnected()) {
      return s.instant("ID_JOINNET_ACTIVE_SESSION");
    }
    if (e.valid_jnj) {
      return s.instant("ID_JOINNET_IDLE_SESSION");
    }
  };
  g.view_port_width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
  g.view_port_height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
  window.addEventListener("resize", function() {
    var a = g.view_port_height;
    g.view_port_height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
    a != g.view_port_height && h.$broadcast(g.WM_HEIGHT_CHANGED);
    a = g.view_port_width;
    g.view_port_width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
    a != g.view_port_width && h.$broadcast(g.WM_WIDTH_CHANGED);
  }, !0);
  document.addEventListener("webkitfullscreenchange", l, !0);
  document.addEventListener("mozfullscreenchange", l, !0);
  document.addEventListener("fullscreenchange", l, !0);
  document.addEventListener("MSFullscreenChange", l, !0);
  a = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_log_level);
  "undefined" === a && (a = hmtg.config.DEFAULT_LOG_LEVEL);
  0 > a && (a = 0);
  hmtg.util.log("log level is set to " + a);
  g.inside_angular++;
  h.tabs = [{active:!1}, {active:!1}, {active:!1}, {active:!1}, {active:!1}, {active:!1}, {active:!1}, {active:!1}];
  a = hmtg.util.getQuery("jnj");
  hmtg.util.getQuery("ask");
  "undefined" === typeof a ? (h.nav_item = "joinnet", h.tabs[2].active = !0, hmtg.util.log("jnj not found from the url")) : (h.nav_item = "joinnet", h.tabs[2].active = !0, hmtg.util.log("jnj from the url: " + a), a = hmtg.util.decode64_url(a), b.connect(a) || m.ShowErrorPrompt(function() {
    return s.instant("ID_INVALID_JNJ");
  }, 20));
  g.inside_angular--;
}]).service("appSetting", ["$rootScope", "hmtgHelper", function(a, e) {
  hmtg.util.test_error & 2 && JSON.parse("undefined");
  var d;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_max_display_item);
  this.max_display_item = "undefined" === d ? e.isMobile ? 50 : 200 : Math.min(1E4, Math.max(0, d));
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_snapshot_delay);
  this.snapshot_delay = "undefined" === d ? 0 : Math.min(10, Math.max(0, d));
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_show_snapshot);
  this.show_snapshot = "undefined" === d ? !0 : !!d;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_show_text);
  this.show_text = "undefined" === d ? !0 : !!d;
  this.show_text = !0;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_show_text_prompt);
  this.show_text_prompt = "undefined" === d ? !0 : !!d;
  this.show_text_prompt = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_max_blob);
  this.max_blob = "undefined" === d ? e.isMobile ? 100 : 500 : Math.min(4E3, Math.max(10, d));
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_show_advanced_function);
  this.show_advanced_function = "undefined" === d ? !1 : !!d;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_meeting_capture_video);
  this.meeting_capture_video = "undefined" === d ? !0 : !!d;
  this.meeting_capture_video = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_meeting_capture_audio);
  this.meeting_capture_audio = "undefined" === d ? !0 : !!d;
  this.meeting_capture_audio = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_meetintg_idle_mode);
  this.meetintg_idle_mode = "undefined" === d ? !1 : !!d;
  this.meetintg_idle_mode = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_auto_download_all);
  this.auto_download_all = "undefined" === d ? !1 : !!d;
  this.auto_download_all = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_use_max_video_bitrate);
  this.use_max_video_bitrate = "undefined" === d ? !1 : !!d;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_max_video_bitrate);
  this.max_video_bitrate = "undefined" === d ? 1E3 : d;
  this.max_video_bitrate = Math.min(1E3, Math.max(10, this.max_video_bitrate));
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_use_max_appdata_bitrate);
  this.use_max_appdata_bitrate = "undefined" === d ? !1 : !!d;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_max_appdata_bitrate);
  this.max_appdata_bitrate = "undefined" === d ? 2E3 : d;
  this.max_appdata_bitrate = Math.min(2E3, Math.max(20, this.max_appdata_bitrate));
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_auto_send_video);
  this.auto_send_video = "undefined" === d ? !0 : !!d;
  this.auto_send_video = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_auto_recv_video);
  this.auto_recv_video = "undefined" === d ? !0 : !!d;
  this.auto_recv_video = !0;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_prefer_questioner);
  this.prefer_questioner = "undefined" === d ? !0 : !!d;
  this.auto_allow_visitor = this.auto_reject_visitor = this.prefer_questioner = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_auto_allow_question);
  this.auto_allow_question = "undefined" === d ? !1 : !!d;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_restrict_audio_decoding);
  this.restrict_audio_decoding = "undefined" === d ? e.isMobile ? !0 : !1 : !!d;
  this.restrict_audio_decoding = !1;
  d = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_max_audio_decoding);
  this.max_audio_decoding = "undefined" === d ? e.isMobile ? e.isiOS ? 2 : 6 : 17 : d;
  this.max_audio_decoding = Math.min(17, Math.max(0, this.max_audio_decoding));
}]).service("jnjSource", [function() {
  var a = "";
  this.save = function(e) {
    a = e;
  };
  this.get = function() {
    return a;
  };
}]).service("jnjContent", [function() {
  this.valid_jnj = !1;
  this.jnj = "";
  this.parseJnj = function(a) {
    this.jnj = a;
    this.valid_jnj = !1;
    this.entries = {};
    for (var e = a.split("\n"), d = 0;d < e.length;d++) {
      if (a = e[d].search("="), -1 != a) {
        var b = e[d].substring(0, a).trim().toLowerCase();
        a = e[d].substring(a + 1).trim();
        this.entries[b] = a;
      }
    }
    "undefined" !== typeof this.entries.codetype && "undefined" !== typeof this.entries.ip && "undefined" !== typeof this.entries.portm ? this.valid_jnj = !0 : hmtg.util.log("invalid jnj");
  };
}]).controller("AboutCtrl", ["$scope", "appVersion", function(a, e) {
  a.app_version = e.full;
  a.jmkernel_version = hmtg.jmkernel.version();
  a.jnkernel_version = hmtg.jnkernel.version();
}]).controller("LangCtrl", ["$scope", "$rootScope", "$translate", "hmtgHelper", function(a, e, d, b) {
  a.lang = d.preferredLanguage();
  a.$watch("lang", function() {
    hmtg.util.localStorage.hmtg_lang = a.lang;
    d.use(a.lang);
  });
}]).controller("LogCtrl", ["$scope", "jnjSource", "JoinNet", "hmtgHelper", "appSetting", function(a, e, d, b, h) {
  function k() {
    a.style_height = {height:0.7 * b.view_port_height + "px"};
    b.inside_angular || a.$digest();
  }
  function g() {
    a.w.show_stat_log ? 768 <= b.view_port_width ? (a.row_fluid = "row-fluid", a.w.show_main_log = !0, a.w.show_toggle1 = !1, a.col_main_log = a.col_stat_log = "col-xs-6") : (a.row_fluid = "", a.w.show_main_log = !1, a.w.show_toggle1 = !1, a.col_main_log = a.col_stat_log = "") : (a.row_fluid = "", a.w.show_main_log = !0, a.w.show_toggle1 = !0, a.col_main_log = a.col_stat_log = "");
    b.inside_angular || a.$digest();
  }
  a.as = h;
  b.inside_angular++;
  k();
  b.inside_angular--;
  a.$on(b.WM_HEIGHT_CHANGED, k);
  a.w = {};
  a.row_fluid = "";
  a.col_main_log = "";
  a.col_stat_log = "";
  a.w.show_main_log = !0;
  a.w.show_stat_log = !1;
  a.w.show_toggle1 = !0;
  a.$watch("w.show_stat_log", function() {
    b.inside_angular++;
    g();
    b.inside_angular--;
  });
  a.$on(b.WM_WIDTH_CHANGED, g);
  a.log = hmtg.util.localStorage.hmtg_log;
  a.refreshLog = function() {
    a.log = hmtg.util.localStorage.hmtg_log;
  };
  a.clearLog = function() {
    a.log = hmtg.util.localStorage.hmtg_log = "";
  };
  a.stat_log = hmtg.util.localStorage.hmtg_log_stat;
  a.refreshStatLog = function() {
    a.stat_log = hmtg.util.localStorage.hmtg_log_stat;
  };
  a.clearStatLog = function() {
    a.stat_log = hmtg.util.localStorage.hmtg_log_stat = "";
  };
  a.$watch(function() {
    return d.status;
  }, function() {
    a.status = d.status;
  });
}]).controller("AppMessageBoxModalCtrl", ["$scope", "$modalInstance", "$modal", "$interval", "$translate", function(a, e, d, b, h) {
  function k() {
    a.local_timeout--;
    a.ok_value = a.ok_value0 + "(" + a.local_timeout + ")";
    a.local_timeout || (b.cancel(a.auto_ok_timerID), a.auto_ok_timerID = null, e.close({timeout:!0}));
  }
  a.local_msgbox_text = a.msgbox_text;
  a.local_hide_cancel = a.hide_cancel;
  a.local_timeout = a.timeout;
  a.local_timeout && (a.local_timeout >>>= 0);
  a.ok_value0 = a.ok_value = h.instant("ID_OK");
  a.local_timeout && (a.ok_value = a.ok_value0 + "(" + a.local_timeout + ")", a.auto_ok_timerID = b(k, 1E3));
  a.ok = function() {
    a.auto_ok_timerID && (b.cancel(a.auto_ok_timerID), a.auto_ok_timerID = null);
    e.close();
  };
  a.cancel = function() {
    a.auto_ok_timerID && (b.cancel(a.auto_ok_timerID), a.auto_ok_timerID = null);
    e.dismiss();
  };
}]).controller("BrowserDetectCtrl", ["$scope", "hmtgAlert", "hmtgHelper", function(a, e, d) {
  d.isiOS && e.add_hidden_item({type:"muted"});
  a.browser_supported = !0;
}]);
angular.module("hmtgs").service("hmtgHelper", ["$rootScope", function(a) {
  this.WM_HEIGHT_CHANGED = "app_height_changed";
  this.WM_WIDTH_CHANGED = "app_width_changed";
  this.WM_SHOW_CHAT_AREA = "show_chat_area";
  this.WM_SHOW_CONTROL_PANEL = "show_user_list";
  this.WM_BROWSER_URL = "browser_url";
  this.WM_UPDATE_DURATION = "update_duration";
  this.WM_PLAYBACK_INIT_STAT = "playback_init_stat";
  this.WM_PLAYBACK_TICK_UPDATE = "playback_tick_update";
  this.WM_PLAYBACK_UPDATE_TICK_STR = "playback_update_tick_str";
  this.WM_UPDATE_ALERT = "update_alert";
  this.WM_UPDATE_MSGR = "update_msgr";
  this.WM_UPDATE_JOINNET = "update_joinnet";
  this.WM_UPDATE_USERLIST = "update_userlist";
  this.WM_UPDATE_VIDEO_WINDOW = "update_video_window";
  this.WM_UPDATE_BOARD = "update_board";
  this.WM_UPDATE_CHAT = "update_chat";
  this.WM_QUIT_SESSION = "quit_session";
  this.WM_RESET_SESSION = "reset_session";
  this.WM_START_SESSION = "start_session";
  this.WM_PLAYBACK_RESTART = "playback_restart";
  this.WM_NET_INIT_FINISH = "net_init_finish";
  this.WM_WORKMODE_CHANGED = "workmode_changed";
  this.WM_UPDATE_PLAYBACK = "update_playback";
  this.WM_FULLSCREEN_CHANGED = "fullscreen_changed";
  this.WM_MAX_DISPLAY_ITEM_CHANGED = "max_display_item_changed";
  this.WM_MEETING_CONTROL = "meeting_control";
  this.WM_IDLE_MODE = "idle_mode";
  this.WM_UPLOAD_SLIDE = "upload_slide";
  this.WM_UPLOAD_IMAGE_LOADED = "upload_image_loaded";
  this.WM_SNAPSHOT_DELAY_CHANGED = "snapshot_delay_changed";
  this.WM_MY_TALKER_STATUS_CHANGED = "my_talker_status_changed";
  this.WM_TALKER_STATUS_CHANGED = "talker_status_changed";
  this.WM_NEW_SPEAKER = "new_speaker";
  this.WM_DELETE_SLIDE = "delete_slide";
  this.WM_POLL_REQUEST = "poll_request";
  this.WM_POLL_RESULT = "poll_result";
  this.WM_TAB_MODE = "change_tab_mode";
  this.WM_SYNC_FULLSCREEN = "sync_fullscreen";
  this.WM_PROMPT_PASSWORD = "prompt_password";
  this.WM_OPEN_JNJ = "open_jnj";
  this.WM_MY_TOKEN_STATUS_CHANGED = "my_token_status_changed";
  this.WM_TOKEN_STATUS_CHANGED = "token_status_changed";
  this.WM_CONTROLLER_STATUS_CHANGED = "controller_status_changed";
  this.WM_AUDIO_RECORDING_CHANGED = "audio_recording_changed";
  this.WM_UPDATE_AUDIO_DECODING = "update_audio_decoding";
  this.WM_CHANGE_CAP = "change_cap";
  this.WM_IMPORT_TRANSCODING = "import_transcoding";
  this.WM_RESET_TRANSCODING = "reset_transcoding";
  this.WM_NEW_PLUGIN = "new_plugin";
  this.WM_CLOSE_PLUGIN = "close_plugin";
  this.WM_COPY_USER_LIST = "copy_user_list";
  this.WM_ADD_USER = "add_user";
  this.WM_UPDATE_APPDATA_BITRATE = "update_appdata_bitrate";
  this.inside_angular = !1;
  this.view_port_width = this.view_port_height = 100;
  a = navigator.userAgent.toLowerCase();
  this.isAndroid = /android/.test(a);
  this.isiOS = /(iphone|ipod|ipad)/.test(a);
  this.isMobile = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(a);
  this.isChrome = "chrome" in window;
  this.checkWorkerInterface = function() {
    var a = new Worker("worker/test_worker.js");
    a.addEventListener("error", window.onerrorWorker, !1);
    try {
      var d = new Uint8Array(1);
      a.postMessage({command:"", data:d}, [d.buffer]);
      return 0 == d.buffer.byteLength ? !0 : !1;
    } catch (b) {
      return!1;
    }
  };
  this.good_worker = this.checkWorkerInterface();
  this.triggerWorkerError = function() {
    var a = new Worker("worker/test_worker.js");
    a.addEventListener("error", window.onerrorWorker, !1);
    a.postMessage({command:"trigger_error"});
  };
  hmtg.util.test_error & 4 && this.triggerWorkerError();
  this.exitFullScreen = function() {
    document.exitFullscreen ? document.exitFullscreen() : document.msExitFullscreen ? document.msExitFullscreen() : document.mozCancelFullScreen ? document.mozCancelFullScreen() : document.webkitExitFullscreen && document.webkitExitFullscreen();
  };
}]);
angular.module("hmtgs").service("hmtgAlert", ["hmtgHelper", "$rootScope", function(a, e) {
  var d = this;
  this.link_array = [];
  this.text_array = [];
  this.hidden_array = [];
  this.status_array = [];
  this.chat_alert_array = [];
  this.need_ring = function() {
    var a;
    for (a = 0;a < this.link_array.length;a++) {
      if (this.link_array[a].need_ring) {
        return!0;
      }
    }
    return!1;
  };
  this.add_link_item = function(b) {
    b.timeout_id = setTimeout(function() {
      b.timeout_action && b.timeout_action();
      var h = d.link_array.indexOf(b);
      -1 != h && (d.link_array.splice(h, 1), e.$broadcast(a.WM_UPDATE_ALERT));
    }, 1E3 * b.timeout);
    this.link_array.push(b);
    e.$broadcast(a.WM_UPDATE_ALERT);
    a.exitFullScreen();
  };
  this.remove_link_item = function(b) {
    var h = this.link_array.indexOf(b);
    -1 != h && (clearTimeout(b.timeout_id), d.link_array.splice(h, 1), e.$broadcast(a.WM_UPDATE_ALERT));
  };
  this.add_text_item = function(b) {
    b.timeout_id = setTimeout(function() {
      b.timeout_action && b.timeout_action();
      var h = d.text_array.indexOf(b);
      -1 != h && (d.text_array.splice(h, 1), e.$broadcast(a.WM_UPDATE_ALERT));
    }, 1E3 * b.timeout);
    this.text_array.push(b);
    e.$broadcast(a.WM_UPDATE_ALERT);
    a.exitFullScreen();
  };
  this.remove_text_item = function(b) {
    var h = this.text_array.indexOf(b);
    -1 != h && (clearTimeout(b.timeout_id), d.text_array.splice(h, 1), e.$broadcast(a.WM_UPDATE_ALERT));
  };
  this.add_hidden_item = function(b) {
    b.timeout_id = setTimeout(function() {
      var h = d.hidden_array.indexOf(b);
      -1 != h && (d.hidden_array.splice(h, 1), e.$broadcast(a.WM_UPDATE_ALERT));
    }, 1E3);
    this.hidden_array.push(b);
  };
  this.update_status_item = function(b) {
    function h() {
      var h = d.status_array.indexOf(b);
      -1 != h && (d.status_array.splice(h, 1), e.$broadcast(a.WM_UPDATE_ALERT));
    }
    for (var k = 0;k < this.status_array.length;k++) {
      clearTimeout(this.status_array[k].timeout_id);
    }
    this.status_array = [];
    b.text && (b.timeout_id = setTimeout(h, 1E3 * b.timeout), this.status_array.push(b));
    e.$broadcast(a.WM_UPDATE_ALERT);
  };
  this.update_chat_alert_item = function(b) {
    for (var h = 0;h < this.chat_alert_array.length;h++) {
      clearTimeout(this.chat_alert_array[h].timeout_id);
    }
    this.chat_alert_array = [];
    b.timeout_id = setTimeout(function() {
      var h = d.chat_alert_array.indexOf(b);
      -1 != h && (d.chat_alert_array.splice(h, 1), e.$broadcast(a.WM_UPDATE_ALERT));
    }, 1E3 * b.timeout);
    this.chat_alert_array.push(b);
    e.$broadcast(a.WM_UPDATE_ALERT);
    a.exitFullScreen();
  };
  this.clear_chat_alert_item = function() {
    for (var b = 0;b < this.chat_alert_array.length;b++) {
      clearTimeout(this.chat_alert_array[b].timeout_id);
    }
    this.chat_alert_array = [];
    e.$broadcast(a.WM_UPDATE_ALERT);
  };
}]).controller("AlertCtrl", ["$scope", "hmtgAlert", "hmtgHelper", "$rootScope", function(a, e, d, b) {
  a.get_link_array = function() {
    return e.link_array;
  };
  a.get_chat_alert_array = function() {
    return e.chat_alert_array;
  };
  a.get_text_array = function() {
    return e.text_array;
  };
  a.get_hidden_array = function() {
    return e.hidden_array;
  };
  a.get_status_array = function() {
    return e.status_array;
  };
  a.close_link = function(a) {
    e.link_array[a].cancel && e.link_array[a].cancel();
    clearTimeout(e.link_array[a].timeout_id);
    e.link_array.splice(a, 1);
  };
  a.close_chat_alert = function(a) {
    clearTimeout(e.chat_alert_array[a].timeout_id);
    e.chat_alert_array.splice(a, 1);
  };
  a.close_text = function(a) {
    e.text_array[a].cancel && e.text_array[a].cancel();
    clearTimeout(e.text_array[a].timeout_id);
    e.text_array.splice(a, 1);
  };
  a.close_status = function(a) {
    clearTimeout(e.status_array[a].timeout_id);
    e.status_array.splice(a, 1);
  };
  a.$on(d.WM_UPDATE_ALERT, function() {
    d.inside_angular || a.$digest();
  });
  b.$on("$translateChangeEnd", function() {
    var a, b = e.link_array;
    for (a = 0;a < b.length;a++) {
      b[a].update && (b[a].text = b[a].update());
    }
    b = e.text_array;
    for (a = 0;a < b.length;a++) {
      b[a].update && (b[a].text = b[a].update());
    }
    b = e.status_array;
    for (a = 0;a < b.length;a++) {
      b[a].update && (b[a].text = b[a].update());
    }
  });
}]);
angular.module("hmtgs").service("hmtgSound", ["hmtgAlert", "hmtgHelper", "$rootScope", "$translate", "appSetting", function(a, e, d, b, h) {
  var k = this;
  this.playback_buffer_size = this.record_buffer_size = 4096;
  this.record_gain = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_record_gain);
  "undefined" === this.record_gain && (this.record_gain = 100);
  this.record_gain = Math.max(0, Math.min(100, this.record_gain));
  this.record_muted = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_record_muted);
  this.record_muted = "undefined" === this.record_muted ? !1 : !!this.record_muted;
  this.playback_gain = hmtg.util.parseJSON(hmtg.util.localStorage.hmtg_playback_gain);
  "undefined" === this.playback_gain && (this.playback_gain = 100);
  this.playback_gain = Math.max(0, Math.min(100, this.playback_gain));
  this.playback_gain = 100;
  this.playback_muted = "undefined" === this.playback_muted ? !1 : !!this.playback_muted;
  this.playback_muted = !1;
  this.MIN_GAIN = 10;
  this.playback_gain_node = this.analyser = this.record_gain_node = null;
  this.record_gain_node_gain_value = this.record_muted ? 0 : this.record_gain / 100;
  this.playback_gain_node_gain_value = this.playback_muted ? 0 : this.playback_gain / 100;
  this.create_playback_gain_node = function() {
    if (!this.playback_gain_node) {
      this.playback_gain_node = this.ac.createGain();
      this.playback_gain_node.gain.value = this.playback_gain_node_gain_value;
      this.playback_gain_node.connect(this.ac.destination);
      this.playback_analyser = this.ac.createAnalyser();
      this.playback_analyser.smoothingTimeConstant = 0.2;
      this.playback_analyser.fftSize = 1024;
      this.playback_gain_node.connect(this.playback_analyser);
      var a = k.playback_buffer_size, b = k.ac, a = b.createScriptProcessor ? b.createScriptProcessor(a, 1, 1) : b.createJavaScriptNode(a, 1, 1);
      k.playback_node = a;
      a.onaudioprocess = function(a) {
      };
      k.playback_analyser.connect(a);
      a.connect(b.destination);
      new Uint8Array(k.playback_analyser.frequencyBinCount);
    }
    return this.playback_gain_node;
  };
  var g = new Audio;
  this.can_mp3 = !!g.canPlayType && g.canPlayType("audio/mpeg");
  this.can_ogg = !!g.canPlayType && g.canPlayType("audio/ogg");
  this.can_wav = !!g.canPlayType && g.canPlayType("audio/wav");
  this.webkit_audio = !1;
  this.audio_turned_on = e.isiOS ? !1 : !0;
  this.typeAudioContext = "";
  "AudioContext" in window ? (this.ac = new window.AudioContext, this.typeAudioContext = "AudioContext") : "webkitAudioContext" in window ? (this.ac = new window.webkitAudioContext, this.webkit_audio = !0, this.typeAudioContext = "webkitAudioContext", this.ac.createGain = this.ac.createGainNode, this.ac.createDelay = this.ac.createDelayNode) : this.ac = null;
  this.ac && (this.merge_analyser = this.ac.createAnalyser(), this.merge_analyser.smoothingTimeConstant = 0.2, this.merge_analyser.fftSize = 1024);
  this.typeURL = "";
  "URL" in window ? this.typeURL = "URL" : "webkitURL" in window ? (window.URL = window.webkitURL, this.typeURL = "webkitURL") : "msURL" in window ? (window.URL = window.msURL, this.typeURL = "msURL") : "oURL" in window && (window.URL = window.oURL, this.typeURL = "oURL");
  this.typeGUM = "";
  "getUserMedia" in navigator ? this.typeGUM = "getUserMedia" : "webkitGetUserMedia" in navigator ? (navigator.getUserMedia = navigator.webkitGetUserMedia, this.typeGUM = "webkitGetUserMedia") : "msGetUserMedia" in navigator ? (navigator.getUserMedia = navigator.msGetUserMedia, this.typeGUM = "msGetUserMedia") : "mozGetUserMedia" in navigator && (navigator.getUserMedia = navigator.mozGetUserMedia, this.typeGUM = "mozGetUserMedia");
  var s = {chars:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encLookup:[], Init:function() {
    for (var a = 0;4096 > a;a++) {
      this.encLookup[a] = this.chars[a >> 6] + this.chars[a & 63];
    }
  }, Encode:function(a) {
    for (var b = a.length, c = "", d = 0;2 < b;) {
      n = a[d] << 16 | a[d + 1] << 8 | a[d + 2], c += this.encLookup[n >> 12] + this.encLookup[n & 4095], b -= 3, d += 3;
    }
    if (0 < b) {
      var e = (a[d] & 252) >> 2, g = (a[d] & 3) << 4;
      1 < b && (g |= (a[++d] & 240) >> 4);
      c += this.chars[e];
      c += this.chars[g];
      2 == b && (e = (a[d++] & 15) << 2, e |= (a[d] & 192) >> 6, c += this.chars[e]);
      1 == b && (c += "=");
      c += "=";
    }
    return c;
  }};
  s.Init();
  for (var g = "", g = [], m = 0;1E4 > m;m++) {
    g[m] = 64 + Math.round(32 * (Math.cos(m * m / 2E3) + Math.sin(m * m / 4E3)));
  }
  m = new function(a) {
    function b(a) {
      return[a & 255, a >> 8 & 255, a >> 16 & 255, a >> 24 & 255];
    }
    function c(a) {
      return[a & 255, a >> 8 & 255];
    }
    function d(a) {
      for (var b = [], c = 0, e = a.length, f = 0;f < e;f++) {
        b[c++] = a[f] & 255, b[c++] = a[f] >> 8 & 255;
      }
      return b;
    }
    this.data = [];
    this.wav = [];
    this.dataURI = "";
    this.header = {chunkId:[82, 73, 70, 70], chunkSize:0, format:[87, 65, 86, 69], subChunk1Id:[102, 109, 116, 32], subChunk1Size:16, audioFormat:1, numChannels:1, sampleRate:8E3, byteRate:0, blockAlign:0, bitsPerSample:8, subChunk2Id:[100, 97, 116, 97], subChunk2Size:0};
    this.Make = function(a) {
      a instanceof Array && (this.data = a);
      this.header.blockAlign = this.header.numChannels * this.header.bitsPerSample >> 3;
      this.header.byteRate = this.header.blockAlign * this.sampleRate;
      this.header.subChunk2Size = this.data.length * (this.header.bitsPerSample >> 3);
      this.header.chunkSize = 36 + this.header.subChunk2Size;
      this.wav = this.header.chunkId.concat(b(this.header.chunkSize), this.header.format, this.header.subChunk1Id, b(this.header.subChunk1Size), c(this.header.audioFormat), c(this.header.numChannels), b(this.header.sampleRate), b(this.header.byteRate), c(this.header.blockAlign), c(this.header.bitsPerSample), this.header.subChunk2Id, b(this.header.subChunk2Size), 16 == this.header.bitsPerSample ? d(this.data) : this.data);
      this.dataURI = "data:audio/wav;base64," + s.Encode(this.wav);
    };
    a instanceof Array && this.Make(a);
  };
  m.header.sampleRate = 22E3;
  m.Make(g);
  var g = s.Encode(m.wav), r, g = {_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", decodeArrayBuffer:function(a) {
    var b = new ArrayBuffer(a.length / 4 * 3);
    this.decode(a, b);
    return b;
  }, decode:function(a, b) {
    var c = this._keyStr.indexOf(a.charAt(a.length - 1)), d = this._keyStr.indexOf(a.charAt(a.length - 2)), e = a.length / 4 * 3;
    64 == c && e--;
    64 == d && e--;
    var g, h, k, m, q = 0, r = 0, c = b ? new Uint8Array(b) : new Uint8Array(e);
    a = a.replace(/[^A-Za-z0-9\+\/\=]/g, "");
    for (q = 0;q < e;q += 3) {
      g = this._keyStr.indexOf(a.charAt(r++)), h = this._keyStr.indexOf(a.charAt(r++)), d = this._keyStr.indexOf(a.charAt(r++)), m = this._keyStr.indexOf(a.charAt(r++)), g = g << 2 | h >> 4, h = (h & 15) << 4 | d >> 2, k = (d & 3) << 6 | m, c[q] = g, 64 != d && (c[q + 1] = h), 64 != m && (c[q + 2] = k);
    }
    return c;
  }}.decodeArrayBuffer(g);
  this.ac && this.ac.decodeAudioData(g, function(a) {
    r = a;
  });
  this.buffer_list = {};
  this.sound_alert_file = this.can_mp3 ? "media/alert.mp3" : this.can_ogg ? "media/alert.ogg" : "media/alert.wav";
  this.sound_alert = new Audio(this.sound_alert_file);
  this.sound_alert.load();
  this.sound_ringin_file = this.can_mp3 ? "media/ringin.mp3" : this.can_ogg ? "media/ringin.ogg" : "media/ringin.wav";
  this.sound_ringin = new Audio(this.sound_ringin_file);
  this.sound_ringin.load();
  this.sound_typing_file = this.can_mp3 ? "media/type.mp3" : this.can_ogg ? "media/type.ogg" : "media/type.wav";
  this.sound_typing = new Audio(this.sound_typing_file);
  this.sound_typing.load();
  this.getUserMediaError = function(a) {
    return "undefined" == typeof a ? "undefined error" : "string" == typeof a ? a : "string" == typeof a.name ? a.name : "string" == typeof a.code ? a.code : a.toString();
  };
  this.turnOnAudio = function() {
    if (!this.audio_turned_on && (this.audio_turned_on = !0, this.sound_alert.load(), this.sound_ringin.load(), this.sound_typing.load(), e.isiOS && this.ac)) {
      var a = this.ac, b = a.createBufferSource();
      this.webkit_audio && (b.start = b.noteOn, b.stop = b.noteOff);
      b.buffer = r;
      var c = a.createGain();
      b.connect(c);
      c.connect(a.destination);
      c.gain.value = 0;
      b.start(0);
    }
  };
  this.playAudio = function() {
    var a = this.ac;
    if (a) {
      var b = a.createBufferSource();
      this.webkit_audio && (b.start = b.noteOn, b.stop = b.noteOff);
      b.buffer = r;
      b.connect(a.destination);
      b.start(0);
    }
  };
  this.playSoundViaAudio = function(a) {
    var b = this.ac, c = b.createBufferSource();
    this.webkit_audio && (c.start = c.noteOn, c.stop = c.noteOff);
    if (this.buffer_list[a]) {
      c.buffer = this.buffer_list[a], c.connect(b.destination), c.start(0);
    } else {
      var d = new XMLHttpRequest;
      d.open("GET", a, !0);
      d.responseType = "arraybuffer";
      d.onload = function() {
        b.decodeAudioData(d.response, function(d) {
          k.buffer_list[a] = d;
          c.buffer = d;
          c.connect(b.destination);
          c.start(0);
        }, function(a) {
        });
      };
      d.send();
    }
  };
  this.playAlertSound = function() {
    this.ac ? this.playSoundViaAudio(this.sound_alert_file) : (this.sound_alert.load(), this.sound_alert.play());
  };
  this.playRinginSound = function() {
    this.ac ? this.playSoundViaAudio(this.sound_ringin_file) : (this.sound_ringin.load(), this.sound_ringin.play());
  };
  this.playTypingSound = function() {
    this.ac ? this.playSoundViaAudio(this.sound_typing_file) : (this.sound_typing.load(), this.sound_typing.play());
  };
  this.ShowErrorPrompt = function(b, d) {
    var c = {};
    c.timeout = d || 20;
    c.update = b;
    c.text = b();
    c.type = "danger";
    c.jnj = "";
    a.add_text_item(c);
    hmtg.util.log("error prompt, '" + c.text + "'");
    h.play_sound && this.playAlertSound();
  };
  this.ShowInfoPrompt = function(b, d, c) {
    var e = {};
    e.timeout = d || 20;
    e.update = b;
    e.text = b();
    e.type = "success";
    e.jnj = "";
    a.add_text_item(e);
    c && this.playTypingSound();
  };
  setInterval(function() {
    a.need_ring() && k.playRinginSound();
  }, 2200);
  hmtg.util.isPrivateStorage && k.ShowErrorPrompt(function() {
    return b.instant("ID_PRIVATE_STORAGE_WARNING");
  }, 30);
  var q = "";
  k.typeAudioContext || (q += (q ? ", " : "") + "Web Audio");
  "" != q && k.ShowErrorPrompt(function() {
    return b.instant("ID_BAD_BROWSER").replace("#feature#", q);
  }, 30);
  !k.audio_turned_on && e.isiOS && (g = {timeout:30, update:function() {
    return b.instant("ID_TURN_ON_IOS_AUDIO_PROMPT");
  }}, g.text = g.update(), g.type = "info", g.click = function(b) {
    k.turnOnAudio();
    e.inside_angular++;
    clearTimeout(a.link_array[b].timeout_id);
    a.link_array.splice(b, 1);
    d.$broadcast(e.WM_UPDATE_ALERT);
    e.inside_angular--;
  }, a.add_link_item(g));
}]);
angular.module("hmtgs").config(["$translateProvider", function(a) {
  a.translations("en", {IDS_APP_NAME:"JoinNet Web App", ID_REQUEST_TALK:"#name# request to talk.", ID_OWNER_TIP:"As meeting owner, you have the following privilege: Terminate Meeting, Disconnect User, Pause Recording, Set JNR Password, Assign Assistant, Assign Presenter, Retrieve Token.", ID_ASSISTANT_TIP:"As assistant, you have the following privilege: Terminate Meeting, Disconnect User, Assign Assistant, Retrieve Token.", ID_PRESENTER_TIP:"As presenter, the token holder assign you the following privilege: #action#.", 
  ID_PRESENTER_TIP2:"You are presenter.", ID_HOLDER_TIP1:"As token holder, you have the following privilege: Assign Presenter, Question Control, Polling, Sync White Board, Sync Tab.", ID_HOLDER_TIP2:"As token holder, you have assigned #name# as presenter with privilege #action#.", ID_HOLDER_TIP3:"As token holder, you have assigned #name# as presenter with privilege #action1# while keeping privilege #action2#.", ID_QUESTIONER_TIP:"As questioner, you have the following privilege: Send Audio, Send Video, Add Marks, Upload Slides.", 
  ID_HAS_REQUEST_TIP:"You need to respond to pending questioner request.", ID_TERMINATE_MEETING_PROMPT:"Are you sure to terminate this meeting?", ID_ADD_VIDEO:"Add to video list", ID_ACTION:"Action", ID_EDIT_VIDEO_LIST:"Edit Video List", ID_SHOW_VIDEO_NAME:"Show Video Name", ID_VIDEO_WINDOW:"Video Window", ID_UNKNOWN_CODEC:"Unknown Codec", ID_DATA_LIMIT_DESCR:"Set the maximal data size that this browser can support. The Web App will skip any data chunk that exceeds this threshold. It is important to set an appropriate value because most browsers will crash if the Web App try to access too large a data chunk.", 
  ID_PROBE_LIMIT:"Probe Limit(buggy browser may crash)", ID_LIMIT_PROBING_INFO:"The probing process increases the data chunk size gradually until error occurs: the good browser just fails while the bad browser crashes.", ID_PROBING_STATUS:"Probing #target#...", ID_PROBING_RESULT:"During last probing test, the browser fails at data chunk of size #target#. Recommend set the threshold to #suggestion#.", ID_PROBING_RESULT2:"During last probing test, the browser encounter no failure. Recommend set the threshold to #suggestion#", 
  ID_TOGGLE_BUTTON_TEXT:"Click here to toggle showing text on buttons. You can always change this setting at 'Options/Web App'.", ID_MULTI_PERMIT_PROMPT:"You attended multiple meetings recently, do you want to get back to one of these meetings?", ID_PERMIT_PROMPT:"You('#name#') attended a meeting recently, do you want to get back to the meeting?", ID_AUTO_FIT:"Auto Fit Size", ID_CAMERA_DESCR:"Camera", ID_MICROPHONE_DESCR:"Microphone", ID_AREA1_DESCR:"Main Panel", ID_AREA2_DESCR:"Second Panel", ID_DESCR_SHOW_TEXT:"Show text description on buttons", 
  ID_PRIVATE_STORAGE_WARNING:"This browser is using private Storage. The changes of settings cannot be saved if the tab is closed.", ID_RECONNECT_NAME_PROMPT:"Reentry Permit can be used to reconnect back to a meeting directly.", ID_SHOW_ERROR_REPORT:"Show Error Report", ID_HIDE_ERROR_REPORT:"Hide Error Report", ID_SHOW_LOG:"Show Log", ID_HIDE_LOG:"Hide Log", ID_START_RECORD_LOOP:"Loop the captured audio to local playback device", ID_STOP_RECORD_LOOP:"Do not loop the captured audio to local playback device", 
  ID_AUTO_SEND_VIDEO:"Automatically Sending Video", ID_PLAY_SOUND_FILE:"Testing Speaker - Play a sound file", ID_STOP_SOUND_FILE:"Testing Speaker - Stop the sound file", ID_MICROPHONE_VOLUME:"Microphone Volume", ID_SPEAKER_VOLUME:"Speaker Volume", ID_MAIN_VIDEO:"Main Video", ID_2ND_VIDEO:"Second Video", ID_SHOW_ONE_VIDEO:"Show One Video", ID_SHOW_TWO_VIDEO:"Show Two Video", ID_DISPLAY_SIZE:"Display Size", ID_FULLSCREEN1:"Fullscreen", ID_FULLSCREEN0:"Leave Fullscreen", ID_SLIDE_LIST:"Slide List", 
  ID_PAGE_LIST:"Page List", ID_THIS_IS_FILE:"This is a file", ID_THIS_IS_SLIDE:"This is a slide", ID_DOWNLOAD_ERROR:"Error in Downloading", ID_DOWNLOAD_OK:"Downloaded", ID_PREV_SLIDE:"Previous Slide", ID_NEXT_SLIDE:"Next Slide", ID_PREV_GROUP:"Previous Group", ID_NEXT_GROUP:"Next Group", ID_UPLOAD_BLANKPAGE:"Add Blank Page", ID_DELETE:"Delete", ID_SAVE_SLIDE:"Save Slide with Mark", ID_SAVE_SLIDE0:"Save Original File", ID_REDOWNLOAD:"Re-Download", ID_DONOT_SYNC:"Donot sync with the presenter", ID_ALLOW_SYNC:"Sync with the presenter", 
  ID_FORCE_SYNC:"Force others to sync with me", ID_ZOOM:"Zoom", ID_TOGGLE_FIT_WINDOW:"Toggle fitting to display area. Current zoom level: ", ID_STOP_UPLOAD:"Stop Uploading", ID_STOP_DOWNLOAD:"Stop Downloading", ID_RESTRICTED_AUDIO_DECODING:"How many audio can be concurrently decoded?", ID_AUDIO_DECODING_DISABLED:"This user's audio is not decoded", ID_MEETNG_MODE:"Meeting Mode", ID_PLAYBACK_MODE:"Playback Mode", ID_DURATION:"Duration", ID_TIME_POS:"Playback Time Position", ID_UPLOADING:"Uploading", 
  ID_DOWNLOADING:"Downloading", ID_PREV_PAGE:"Go Back", ID_NEXT_PAGE:"Go Forward", ID_RELOAD_PAGE:"Reload this page", ID_OPEN_NEW_WINDOW:"Open this page in a new tab", ID_TOGGLE_SEND:"Toggle Sending", ID_TOGGLE_RECEIVE:"Toggle Receiving", ID_STOP_IMPORTING:"Stop the importing", ID_NEW_MYPICTURE:"Open file for new My Picture", ID_DELETE_MYPICTURE:"Delete current My Picture", ID_SHOW_NAME_LIST:"Show Name List", ID_HIDE_NAME_LIST:"Hide Name List", ID_SAVE_FILE:"Save to file", ID_UPLOAD_WHITEBOARD:"Upload to White Board", 
  ID_CROP_LEFT:"Crop the left side", ID_CROP_TOP:"Crop the top side", ID_CROP_RIGHT:"Crop the right side", ID_CROP_BOTTOM:"Crop the bottom side", ID_TOGGLE_LEGEND:"Toggle Legend Display", ID_BROADCAST_VOLUME:"Broadcast Volume", ID_LOCAL_PLAY_VOLUME:"Local Play Volume", ID_ERROR_TAINTED_CANVAS:"Error! The canvas data cannot be saved because the data comes from a different domain!", ID_ERROR_EXPORT_CANVAS_DATA:"Error! The canvas data cannot be saved!", ID_IMPORTED_VIDEO:"Imported Video", ID_CAPTURE_RATE:"Capture Rate", 
  ID_DISPLAY_RATE:"Display Rate", ID_CAPTURED_SCREEN:"Screen Capture", ID_START_SCREEN_CAPTURE:"Start Screen Capture", ID_START_SCREEN_CAPTURE2:"Start Screen Capture(Individual Window)", ID_STOP_SCREEN_CAPTURE:"Stop Screen Capture", ID_TOGGLE_SCREEN_AS_VIDEO:"Toggle using captured screen as video source", ID_START_VIDEO_SENDING:"Start Video Sending", ID_STOP_VIDEO_SENDING:"Stop Video Sending", ID_REMOTE_FULLSCREEN:"Toggle fullscreen status of other participants", ID_SHARER_NAME:"The participant that shares the desktop", 
  ID_ALLOW_REMOTE_CONTROL:"Allow to be remotely controlled", ID_ALLOW_CONTROL_PROMPT:"Do you allow #user# to remotely control your desktop?", ID_USE_MAX_APPDATA_BITRATE:"Set Maximum Appdata Sending Bitrate", ID_DATA_SOURCE:"Data Source", ID_COLOR_DEPTH:"Color Depth", ID_24BIT_COLOR:"24bit (true color)", ID_16BIT_COLOR:"16bit (true color)", ID_8BIT_COLOR:"8bit (256 color)", ID_4BIT_COLOR:"4bit (16 color)", ID_2BIT_COLOR:"2bit (4 color)", ID_1BIT_COLOR:"1bit (2 color)", ID_8BIT_GRAY:"8bit (256 grayscale)", 
  ID_4BIT_GRAY:"4bit (16 grayscale)", ID_SET_JNR_PASSWORD:"Set JNR Password", ID_HAS_JNR_PASSWORD:"[The JNR will be password-protected]", ID_TARGET_RATE:"Target Rate", ID_SENDING_RATE:"Sending Rate", ID_RECV_RATE:"Receiving Rate", ID_LOSS_RATE:"Loss Rate", ID_DESKTOP_SHARING:"Shared Desktop", ID_REMOTE_CONTROL:"Remote Control", ID_PAUSE_RECORDING:"Pause Recording", ID_RESUME_RECORDING:"Resume Recording", ID_NO_RECORDING:"[This meeting is not recorded]", ID_RECORDING_PAUSED:"[The recording is paused]", 
  ID_RECORDING_ARCHIVED:"[This meeting's recording file will be archived]", ID_VIDEO_CAPTURE_SIZE:"Video Capture Size", ID_VIDEO_SENDING_SIZE:"Video Sending Size", ID_VIDEO_RECVING_SIZE:"Video Recving Size", ID_INTERNAL_ID:"Internal ID", ID_TEST:"Test", ID_AUDIO_TEST:"Audio Test", ID_VIDEO_TEST:"Video Test", ID_SCREEN_CAPTURE_TEST:"Screen Capture Test", ID_MYPICTURE_UPLOADING:"My Picture is being uploaded to the MCU", ID_LEAVE_AND_RECONNECT:"The Web App will now leave the meeting and then reconnect back", 
  ID_INPUT_JNJ:"Input/Modify jnj here", ID_WEB_APP:"Web App", ID_STATISTICS:"Statistics", ID_SERVER_CONFIG:"Server Bandwidth Configuration", ID_SENDING:"Sending", ID_RECVING:"Receiving", ID_AUDIO_CODEC:"Audio Codec", ID_AUDIO_TARGET_RATE:"Audio Target Rate", ID_AUDIO_SENDING_RATE:"Audio Sending Rate", ID_VIDEO_CODEC:"Video Codec", ID_VIDEO_TARGET_RATE:"Video Target Rate", ID_VIDEO_SENDING_RATE:"Video Sending Rate", ID_NOT_CONNECTED:"Not Connected", ID_AUDIO_RECVING_RATE:"Audio Receiving Rate", ID_AUDIO_LOSS_RATE:"Audio Loss Rate", 
  ID_VIDEO_RECV_RATE:"Video Receiving Rate", ID_VIDEO_LOSS_RATE:"Video Loss Rate", ID_VIDEO_DISPLAY:"Video Display", ID_VERSION:"version", ID_IMPORT_HTML5:"Import HTML5 audio/video as source", ID_CROSS_ORIGIN_INFO:"If the media link contain video and is from a cross domain, the server must allow the JoinNet Web App site to access the video content. Otherwise, the video can only be viewed locally but not be re-broadcasted.", ID_TRANSCODING_INFO:"When re-broadcasting the audio/video, the original media data will be transcoded using the Meeting Server's configuration. The quality may be restricted due to this transcoding.", 
  ID_AUTO_PLAY:"Auto Play", ID_AUDIO_ONLY:"Audio Only", ID_MEDIA_LINK:"Link Address", ID_MEDIA_NAME:"Link Name", ID_CHOOSE_MEDIA:"Choose a link", ID_LOOP:"Loop", ID_BROADCAST_VIDEO:"Broadcast Video", ID_MUTE_TRANSCODING:"Mute broadcasting", ID_UNMUTE_TRANSCODING:"Unmute broadcasting", ID_MUTE_LOCAL:"Mute local play", ID_UNMUTE_LOCAL:"Unmute local play", ID_VIDEO_NOT_BROADCASTED:"The link's video is played locally but not broadcasted.", ID_CROSS_DOMAIN_VIDEO1:"The link's video cannot be broadcasted because the link is cross domain and doesn't allow this site to re-broadcast it.", 
  ID_CROSS_DOMAIN_VIDEO2:"The link's video cannot be broadcasted because this browser doesn't support cross domain video link.", ID_ERROR_LOAD_HTML5_MEDIA:"Cannot load the HTML5 media link", ID_MENU:"Menu", ID_CONNECT:"Connect", ID_ALLOW_DECODING:"Allow Audio Decoding", ID_RESTRICT_AUDIO_DECODING:"If your device has limited computation power, such as a mobile device, set the upper limit of concurrent audio decoding.", ID_AUTO_RECONNECT_PROMPT:"Your network is disconnected from MCU server. The Web App will try to reconnect shortly.", 
  ID_AUTO_DISCONNECTION_PROMPT:"There is no activity for a long time, the Web App will automatically disconnect the playback. Click OK to avoid the automatic disconnection.", ID_LOSE_AUDIO_CAP:"Warning! It seems that #user# lose audio capability.", ID_MYPICTURE:"My Picture", ID_RECONNECT_NAME:"Reentry Permit", ID_SSRC:"User Index", ID_INVALID_IMAGE:"Invalid image file", ID_IMAGE_FILE_READ_ERROR:"Cannot read the image file", ID_SYNC_FULLSCREEN:"The presenter switches to fullscreen, the web app need your permission to follow. Do you want to switch to fullscreen?", 
  ID_IFRAME_FOLLOW_LINK_ERROR:"The web app cannot follow links in cross-domain web pages, please copy the link address and paste it directly to the address bar.", ID_MYPICTURE_DESCR:"Without camera, you can configure a My Picture, which can be used in place of the video. Your original picture file may be down-sampled and/or changed to .png format to decrease size.", ID_REPLACE_MYPICTURE_PROMPT:"You just changed the My Picture setting. Right now, you have an active meeting with existing My Picture, you need to leave and re-join the meeting to update the My Picture in the meeting. Do you want to leave and re-join the meeting?", 
  ID_THIRDPARTY_PASSWORD:"Please input the authentication password:", ID_JNR_SHARING_PASSWORD:"The JNR Sharing is password-protected, please input the sharing password:", ID_JNR_PASSWORD:"The JNR is password-protected, please input the JNR password:", ID_LEGEND:"Legend", ID_LEGEND_OWNER:"Meeting Owner", ID_LEGEND_ASSISTANT:"Assistant", ID_LEGEND_CONTROLLER:"Presenter", ID_LEGEND_HOLDER:"Token Holder", ID_LEGEND_QUESTIONER:"Questioner", ID_LEGEND_PENDING_QUESTIONER:"Pending Questioner", ID_TAB_USER:"Users", 
  ID_TAB_AUDIO:"Audio", ID_TAB_VIDEO:"Video", ID_TAB_SLIDE:"Slide", ID_POLL:"Poll", ID_POLL_REQUEST:"Poll Request", ID_POLL_RESULT:"Poll Result", ID_POLL_ANSWER:"Answer", ID_POLL_COUNT:"User Count", ID_POLL_PERCENT:"Percent", ID_SNAPSHOT:"Snapshot", ID_SNAPSHOT_TITLE:"Snapshot", ID_DESCR_SHOW_SNAPSHOT:"Show snapshot button at navigation bar", ID_DESCR_SNAPSHOT_DELAY:"Snapshot delay(in seconds)", ID_CROPPING:"Cropping", ID_DELETE_GROUP:"Delete all the slides in this group", ID_DELETE_SLIDE_PROMPT:"Are you sure to delete this slide?", 
  ID_DELETE_GROUP_PROMPT:"Are you sure to delete all the slides in this group?", ID_SMALL_2ND_VIDEO:"Overlapping 2nd video with smaller size", ID_EQUAL_2ND_VIDEO:"Side by side 2nd video with equal size", ID_UPLOAD_AS_FILE:"Upload as file", ID_UPLOAD_TO_GROUP:"Upload to a slide group", ID_SLIDE_GROUP:"Slide Group Name", ID_SLIDE_TITLE:"Slide Title", ID_FILE_NAME:"File Name", ID_CONVERSION_OPTIONS:"The file need to be converted to slides at a conversion server. Please decide the following conversion options:", 
  ID_NO_CONVERSION:"The file need to be converted to slides at a conversion server, which is not set up at this meeting server. Please ask the administrator to set up a conversion server.", ID_SLIDE_PAGE:"Page(Enter either a single page number or a single page range. For example, 5-12. All pages will be converted if the entry is empty)", ID_NEED_TRUSTED_SERVER:"The file content is sensitive and need a trusted conversion server", ID_CONVERT_TO_FILE_ON_FAILURE:"If conversion fails, upload as file", 
  ID_CONVERT_ALL_OR_NONE:"Convert all pages or none", ID_UPLOAD_BLANK_PAGE:"Upload Blank Page", ID_UPLOAD_SLIDE:"Upload Slide", ID_UPLOAD_FILE:"Upload File", ID_CHOOSE_GROUP:"Choose Group", ID_CONVERSION_FAILED:"Converting to slides failed for file #file#", ID_UPLOAD_READING:"Reading data...", ID_UPLOAD_COMPRESSING:"Compressing...", ID_UPLOAD_CONVERTING:"Converting to slides...", IDS_UPLOAD_EXISTING_GROUP:'Are you sure to upload to the existing group "#group#"?', ID_ALLOW_QUESTION:"Allow Question", 
  ID_SKIP_QUESTION:"Skip Question", ID_END_QUESTION:"End Question", ID_ASK_QUESTION:"Ask Question", ID_END_MY_QUESTION:"End My Question", ID_SET_CONTROLLER:"Set Presenter...", ID_RESET_CONTROLLER:"Reset Presenter", ID_GIVEOUT_TOKEN:"Give Out Token", ID_ASSIGN_ASSISTANT:"Assign Assistant", ID_RESET_ASSISTANT:"Reset Assistant", ID_RETRIEVE_TOKEN:"Retrive Token", ID_DISCONNECT_USER:"Disconnect User", ID_BAN_USER:"Permanently Disconnect User", ID_TERMINATE_MEETING:"Terminate Meeting", ID_AUTO_REJECT_VISITOR:"Auto Reject Visitor", 
  ID_AUTO_ALLOW_VISITOR:"Auto Allow Visitor", ID_AUTO_ALLOW_QUESTION:"Auto Allow Question", ID_MEETING_CONTROL_TITLE:"Configure Presenter's Task", ID_CONTROLLER_QUESTION:"Allow/End Question", ID_CONTROLLER_POLL:"Poll", ID_CONTROLLER_SYNC:"Sync White Board", ID_CONTROLLER_SYNC_TAB:"Sync Tab", ID_DESCR_MAX_DISPLAY_ITEM:"Maximum items to display for certain elements, such as slide title, slide page, control panel, check messsage, etc. Higher number consume more computation resource. Choose a low number if the device has limited computation power(such as mobile device) or high computation load(such as receiving many video at the same time).", 
  ID_AUTO_SELECT:"Auto Select", ID_NO_SHOW:"Do Not Show", ID_CAMERA_VIEW:"Camera View", ID_PREFER_QUESTIONER:"Prefer Questioner's Video By Default", ID_AUTO_RECV_VIDEO:"Automatically Receiving Video", ID_USE_MAX_VIDEO_BITRATE:"Set Maximum Video Sending Bitrate", ID_AUTO_DOWNLOAD_ALL:"Automatically download all slides", ID_SHOW_ADVANCED_FUNCTION:"Show Advanced Functions", ID_SIMULATE_DISCONNECT:"Network Disconnect", ID_SIMULATE_RECONNECT:"Disconnect & Reconnect", ID_BAD_BROWSER:"The browser you're using doesn't support #feature#. Some functions may not work.", 
  ID_AUDIO_CODEC_PROMPT:"Audio Codec", ID_VIDEO_CODEC_PROMPT:"Video Codec", ID_LOAD_LAST_JNJ:"Load Last Jnj", ID_RESTORE_JNJ:"Restore Jnj", ID_STATUS_NAME:"Connection Status", ID_LOG:"Log", ID_OPEN_JNJ:"Open Jnj...", ID_REFRESH_LOG:"Refresh Log", ID_CLEAR_LOG:"Clear Log", ID_SHOW_STAT_LOG:"Show Statistics Log", ID_HIDE_STAT_LOG:"Hide Statistics Log", ID_STAT_LOG:"Statistics Log", ID_SHOW_ONE_AREA:"Show one component only", ID_SHOW_TWO_AREA:"Show two components", ID_SELECT_AREA:"Select component to show", 
  ID_SELECT_AREA2:"Select second component to show", ID_AREA_RATIO:"Choose components width ratio", ID_SCROLL_TO_TOP:"Scroll to top", ID_SCROLL_TO_BOTTOM:"Scroll to bottom", ID_INVALID_JNJ:"Invalid Jnj", ID_JOINNET_ACTIVE_SESSION:"You are in an ongoing JoinNet session.", ID_JOINNET_IDLE_SESSION:"You have an existing idle JoinNet session.", ID_CONTINUE_PROMPT:"Do you want to continue?", ID_RESET:"Reset", ID_CIPHER:"Cipher", ID_BITS:"bits", ID_RESET_ALL:"Reset All", ID_RESET_ALL_WARNING:"*WARNING* This will reset EVERYTHING: quit existing JoinNet session, quit and remove all existing messenger connections, delete all logs and histories, reset all settings. Do you want to continue?", 
  ID_PROMPT:"Launch JoinNet", ID_JNJ_DESCR:"You receive a jnj file. You can launch a native JoinNet (need installation if you haven't installed one yet), or simply use this Web App. How are you going to launch the JoinNet? ", ID_LAUNCH_WEBAPP:"Use Web App", ID_LAUNCH_NATIVE_JOINNET:"Use Native JoinNet", ID_NATIVE_FAIL_DESCR:"If your device fails to launch native JoinNet using this button, please copy the content of the jnj (see below) and save it to a .jnj file(using utf8 encoding) and try to launch native JoinNet from the file.", 
  ID_RELAUNCH_NATIVE_JOINNET:"Relaunch Using Native JoinNet", ID_JOINNET_DESCR:"If your device support the native JoinNet but haven't installed yet, click the following button to download.", ID_DOWNLOAD_JOINNET:"Download Native JoinNet", ID_NATIVE_APP:"Native App", ID_NATIVE_DESCR:"Native JoinNet and JoinNet Messenger support advanced functions. If your device support the native App, please download from the following links. For android device, you can also download 'JoinNet Messenger' directly from Google Play Store.", 
  ID_DOWNLOAD_WIN_JOINNET:"JoinNet (Windows)", ID_DOWNLOAD_WIN_MSGR:"JoinNet Messenger (Windows)", ID_DOWNLOAD_ANDROID_MSGR:"JoinNet Messenger (Android)", ID_PLAYBACK_RANDOM_ACCESS:"Jump to...", ID_PLAYBACK_REPEAT:"Repeat", ID_PLAYBACK_BACKWARD:"Backward", ID_PLAYBACK_FORWARD:"Forward", ID_PLAYBACK_STOP:"Stop", ID_PLAYBACK_PAUSE:"Pause", ID_PLAYBACK_RESUME:"Resume", ID_PLAYBACK_PAUSED:"Backward jump has high overhead, playback is paused for you. Please resume when ready.", IDS_TIME_UNIT_SECOND:"seconds", 
  IDS_TIME_UNIT_MS:"milliseconds", IDC_CHECK_SHOW_MS:"Show millisecond", IDC_CHECK_SHOW_TOOLTIP:"Show tooltip", ID_RECORDING_TIME:"Recording Time", ID_BANDWIDTH:"Bandwidth", ID_TURN_ON_IOS_AUDIO_PROMPT:"Click to turn on Audio. You can also click any navigation item to turn on Audio.", ID_APP_URL:"Corresponding JoinNet Web App URL", ID_CANNOT_CAPTURE_AUDIO:"Cannot capture audio: ", ID_BROWSER_NOT_SUPPORT:"This browser doesn't support #feature#", ID_FEATURE_AUDIO_RECORD:"Audio Capture", ID_FEATURE_AUDIO_PLAYBACK:"Audio Playback", 
  ID_FEATURE_VIDEO_CAPTURE:"Video Capture", ID_FEATURE_SCREEN_CAPTURE:"Screen Capture", ID_ALLOW_CAPTURE_AUDIO_PROMPT:"The browser may ask your permission to use the microphone, please choose 'Allow'. Moreover, Earphone is preferred to avoid echo.", ID_AUDIO_LOOP_PROMPT:"Captured audio will be played back immediately so that you will hear yourself.", ID_START_VIDEO_RECVING:"Start Video Recving", ID_STOP_VIDEO_RECVING:"Stop Video Recving", ID_START_VIDEO_CAPTURE:"Start Video Capture", ID_STOP_VIDEO_CAPTURE:"Stop Video Capture", 
  ID_START_RECORD:"Start Audio Capture", ID_STOP_RECORD:"Stop Audio Capture", ID_RECORD:"Record", ID_MUTE_RECORD:"Mute Microphone", ID_UNMUTE_RECORD:"Unmute Microphone", ID_MUTE_SPEAKER:"Mute Speaker", ID_UNMUTE_SPEAKER:"Unmute Speaker", ID_TEST_SPEAKER:"Test Speaker", ID_NEED_ADJUST_VOLUME:"You may need to unmute or increase the volume to hear audio.", ID_ALLOW_CAPTURE_VIDEO_PROMPT:"The browser may ask your permission to use the camera, please choose 'Allow'.", ID_START:"Start", ID_STOP:"Stop", 
  ID_FEATURE_VIDEO:"Video Capture", ID_CANNOT_CAPTURE_VIDEO:"Cannot capture video: ", ID_ALLOW_CAPTURE_SCREEN_PROMPT:"The browser may ask your permission to share your screen, please choose 'Yes'.", ID_FEATURE_SCREEN:"Screen Capture", ID_CANNOT_CAPTURE_SCREEN:"Cannot capture screen: ", ID_USER_GUIDE:"User Guide", ID_MEETING_CAPTURE_VIDEO:"Once enter a meeting, start video capture", ID_MEETING_CAPTURE_AUDIO:"Once enter a meeting, start audio capture", ID_MEETING_IDLE_MODE:"Stop capturing and sending audio/video when I become the only participant in a meeting", 
  ID_UNKNOWN_MEDIA:"Unable to play the media(#type#) from user #name#.", ID_WEBOFFICE_VISITOR_TITLE:"%s's Web Office", ID_VISITOR:"Visitor", ID_OWNER:"Meeting Owner", ID_NAME_LABEL:"Please specify your name:", ID_PASSWORD_LABEL:"Please specify your password:", IDS_FILE_WRONG_VERSION:"Sorry, the version of the recorded file is %d.%d, which is not supported by this JoinNet.", IDS_WRONG_VERSION:"This version of JoinNet is out-dated.", IDS_POINTER:"Pointer", IDS_FREEHAND:"FreeHand", IDS_TEXT:"Text", 
  IDS_LINE:"Line", IDS_RECTANGLE:"Rectangle", IDS_RECTANGLE_FILLED:"Solid rectangle", IDS_HIGHLIGHT:"HighLight", IDS_SELECT:"Select", IDS_IMAGE:"Paste Image", IDS_ERASER:"Eraser", IDS_COLOR_TOOLTIP:"Choose pen color", IDS_PENWIDTH_TOOLTIP:"Choose pen width", IDS_ADDRESS:"Address", IDS_JOINT_WEB_BROWSING:"Joint Web Browsing", IDS_CONTROL_PANEL_TITLE:"Online Users (%d)", ID_CONTROL_PANEL:"Control Panel", ID_TEXT_CHAT:"Text Message", ID_WHITE_BOARD:"White Board", IDC_CHECK_OTHER_USER:"Show Other Users", 
  IDC_CHECK_OFFLINE_USER:"Show Offline Users", IDS_SHOW_USER_GROUP:"Show the users in this group", IDS_HIDE_USER_GROUP:"Hide the users in this group", IDS_SHOW_OTHER_USER:"Show the users in this group - the list may not be complete", IDS_HIDE_OTHER_USER:"Hide the users in this group - the list may not be complete", IDS_SHOW_SHARE_FILE:"Show Shared Recording File", IDS_HIDE_SHARE_FILE:"Hide Shared Recording File", IDS_SHOW_EVENT:"Show scheduled events", IDS_HIDE_EVENT:"Hide scheduled events", IDS_SHOW_PUBLISH_FILE:"Show Published Recording File", 
  IDS_HIDE_PUBLISH_FILE:"Hide Published Recording File", IDS_SHOW_MISSED_CALLS:"Show missed calls", IDS_HIDE_MISSED_CALLS:"Hide missed calls", IDS_SHOWHIDE_USER_GROUP:"Show/Hide the users in this group", IDS_CONNECTING_MCU:"Connecting to MCU server.....", IDS_SLIDE_COLUMN:"Slide/File", IDD_DIALOG_SHARE_PARAM:"Input Share Parameter", IDD_DIALOG_SUBJECT:"Share Subject", IDD_DIALOG_VIEW_RECORD:"Shared Playback Record", IDD_DIALOG_SIGNIN:"Add Office", IDD_DIALOG_ASYNC_REQUEST:"Asynchronous Request", 
  IDD_DIALOG_PICK_USERID:"Pick User ID", IDD_DIALOG_IM_THREAD:"Find a Conversation Log", IDD_DIALOG_PERSONAL_INFO:"Set Personal Message", IDD_DIALOG_LOGLEVEL:"Log Level", IDD_DIALOG_OPTION_GENERAL:"Options", IDD_DIALOG_SHARE_RESULT:"Share Recording File", IDD_DIALOG_JEDITOR:"Edit", IDC_SET_STATUS:"My Status", IDC_STATIC_1_HOMEPAGE:"Web Office Home Page:", IDC_CHECK_GUEST:"Connect as Guest", IDC_STATIC_PASSWORD:"Password:", IDC_STATIC_1_YOURNAME:"Input Your Name:", IDC_DELETE:"Delete", IDC_SEND:"Send", 
  IDC_SEARCH:"Search", IDC_STATIC_1_OFFICE:"Office:", IDC_STATIC_2_YOU:"You are:", IDC_STATIC_3_PEER:"The peer is:", IDC_STATIC_4_KEYWORD:"Keyword:", IDC_STATIC_5_RANGE:"Time range(in days):", IDC_STATIC_2_URL:"Visit URL:", IDC_STATIC_3_USERNAME:"User Name:", IDC_STATIC_4_EMAIL:"Email:", IDC_STATIC_5_OLD:"Old Password:", IDC_STATIC_6_NEW:"New Password:", IDC_STATIC_7_CONFIRM:"Confirm New Password:", IDC_CHECK_DENY_MESSAGE:"Disallow guest leaving message to me", IDC_STATIC_1_NAMETO:"Name to:", IDC_STATIC_2_GROUP:"Please input the group name here:", 
  IDC_STATIC_1_TITLE:"Title:", IDC_STATIC_4_CAUTION:"Caution: If you lose or forget the password, it cannot be recovered. It is advisable to keep a list of passwords and their corresponding document names in a safe place. (Remember that passwords are case-sensitive.)", IDC_CHECK_EXPIRATION:"Set Expiration Date", IDC_STATIC_1_EXPIRE:"How many days will the share URL expire?", IDC_CHECK_PASSWORD:"Use Password", IDC_STATIC_2_PASSWORD:"The user need to input the following password to play this file:", 
  IDC_SHARE:"Share through Messenger", IDC_EMAIL:"Share through Email", IDC_COPY_ALL:"Copy All", IDC_STATIC_1_LEVEL:"Choose log level. The larger the level, the more information will be logged.", IDC_CHECK_ALERT_ONLINE:"Display alerts when contacts come online", IDC_CHECK_ALERT_NEWMESSAGE:"Display alerts when a message is received", IDC_CHECK_PLAYSOUND:"Play a sound while displaying the alert", IDC_CHECK_CUTALL:"Cut All In Time Range:", IDC_CHECK_CUT_VIDEO:"Cut All Video", IDC_CHECK_TCV:"Keep Token Holder and Presenter's Video Only", 
  IDC_CHECK_CAV:"Keep Token Holder and Presenter's Audio/Video Only", IDC_CHECK_CAT:"Cut All Text Chat", IDC_CHECK_BAU:"Change All Joint Browsing URL to Blank Page", IDC_STATIC_CUT_START:"Start:", IDC_STATIC_CUT_END:"End:", IDC_STATIC_ADVANCED_COMMAND:"Advanced Command:", ID_SKIN_LANG_AUTO:"Auto Detect", ID_TEXT_SIZE_LARGEST:"Largest", ID_TEXT_SIZE_LARGER:"Larger", ID_TEXT_SIZE_MEDIUM:"Medium", ID_TEXT_SIZE_SMALLER:"Smaller", ID_TEXT_SIZE_SMALLEST:"Smallest", ID_EXIT:"Exit", ID_SIGNOUT_ALL:"Disconnect All", 
  ID_RECONNECT:"Reconnect", ID_SIGNOUT:"Disconnect", ID_MOVE_UP:"Move Up", ID_MOVE_DOWN:"Move Down", ID_CHECK_MESSAGE:"Check Message", ID_REFRESH:"Refresh Content", ID_MARK_READ:"Mark as Read", ID_MARK_UNREAD:"Mark as Unread", ID_INPUT_SELECT_ALL:"Select All", ID_PLAYBACK:"Playback", ID_SORT_BASE4:"View Count", ID_SORT_BASE5:"Web Title", ID_PICK_USERID:"Pick", ID_TRANSFER:"Transfer File", ID_REMOVE_FILE:"Remove", ID_REMOVE_ALL_FILE:"Remove All", ID_ERASE_CALL:"Erase", ID_ERASE_ALL:"Erase All Missed Calls", 
  ID_EDIT_PROFILE:"Edit Profile", ID_SHOW_HOMEPAGE:"Go To Website", ID_VIEW_PROFILE:"View Account Information", ID_RENAME:"Rename Office", ID_IMPORT_CONTACT_LOCAL:"Import Contact Group", ID_EXPORT_CONTACT_LOCAL:"Export Contact Group", ID_IMPORT_CONTACT_WEB:"Import Contact Group From Web", ID_EXPORT_CONTACT_WEB:"Export Contact Group To Web", ID_PICKCONTACT:"Add Contacts", ID_RENAMEGROUP:"Rename Contact Group", ID_DELETEGROUP:"Delete Contact Group", ID_DELETECONTACT:"Delete Contact", ID_CHANGE_TITLE:"Change JNR Title", 
  ID_CHANGE_JNR_PASSWORD:"Change JNR Password", ID_DOWNLOAD:"Download", ID_UPLOAD:"Upload", ID_SET_GROUP:"Set Group", ID_GROUP_TOTAL:"Show Group Statistics", ID_SHARE:"Share File", ID_SHARE2:"Share File with Restriction", ID_VIEW_RECORD:"View Shared Playback Record", ID_UNSHARE:"Unshare File", IDS_NO_WEB_OFFICE_IN_LIST:"No web office in your list.", IDS_FORMAT_OFFICE_NAME1:"guest @ #homepage#", IDS_FORMAT_OFFICE_NAME2:"#userid# @ #homepage#", IDS_GUEST:"Guest", IDS_STATUS_APPEAROFFLINE:"Appear Offline", 
  IDS_STATUS_OFFLINE:"Offline", IDS_STATUS_BUSY:"Busy", IDS_STATUS_RIGHTBACK:"Be Right Back", IDS_STATUS_AWAY:"Away", IDS_STATUS_INMEETING:"In Meeting", IDS_STATUS_OFFICEOPEN:"Office Open", IDS_STATUS_ONLINE:"Online", IDS_OTHER_USERS:"Other Users", IDS_FORMAT_OTHER_USERS:"Other Users (%d) - The list may not be complete", IDS_FORMAT_CONFIRM_REMOVE_OFFICE:"Are you sure to remove Web Office #homepage#?", IDS_FORMAT_WBMSGR_VERSION:"JoinNet Messenger Version %d.%d.%d%s", IDS_FORMAT_INVITE:"Invite #target# to #office#", 
  IDS_FORMAT_VISIT:"Visit #username#", IDS_FORMAT_PREPARE_VISIT:"Prepare to visit #username#...", IDS_FORMAT_PREPARE_INVITE:"Prepare to invite #username# to #inviter_office#...", IDS_FORMAT_ALERT_INVITE:"You (#userid# @ #office#) are invited to join (#inviter_id# @ #inviter_office#)'s Web Office. Do you want to accept this invitation?", IDS_FORMAT_ALERT_VISIT1:"#visitor# wish to visit your web office(#office#). Do you want to launch your web office?", IDS_FORMAT_ALERT_VISIT2:"#visitor# wish to visit your web office(#userid# @ #homepage#). Do you want to launch your web office?", 
  IDS_CONNECTION_INITED:"Connection is initialized", IDS_FORMAT_DISK_USAGE_INFO:"%dMB (Quota: %dMB)", IDS_FORMAT_FILE_COUNT:"%d Unread (%d Total)", IDS_CONVERSATION:"Conversation", IDS_SHORT_MESSAGE_TOO_LONG:"The short message is too long.", IDS_SAYS:"says:", IDS_OFFICE_IS:"The office is #name#", IDS_LOG_READ_ERROR:"Error occurs reading the log: #error#", IDS_LOG_READ1:"The log is read at #time#", IDS_LOG_READ2:"The log is read at #time#, time range: #number# days", IDS_LOG_REFRESH:"Refresh", IDS_FILE_SENDING:"File Sending", 
  IDS_FILE_RECVING:"File Receiving", IDS_FILE_NAME:"File Name", IDS_FILE_PATH:"File Path", IDS_FILE_SIZE:"File Size", IDS_PROGRESS:"Progress", IDS_TRANSFER_CMD_RECEIVE:"Receive", IDS_TRANSFER_CMD_OPEN:"Open", IDS_TRANSFER_CMD_CANCEL:"Cancel", IDS_SEND_WAIT:"Waiting for #peer_name#'s response...", IDS_SEND_LOSE_CONTACT:"You have lost contact with the receiver, the file transfer will automatically resume when the contact is re-established.", IDS_FILE_TRANSFER_DONE:"Done", IDS_TRANSFER_DISCONNECT:"You are forced to pause the file transfer due to network error. The file transfer will automatically resume when the network connection restores.", 
  IDS_RECV_WAIT:"Do you want to receive this file?", IDS_FORMAT_RATE:"#size# at #rate#; #time# remain", IDS_FILENAME_TOOLONG:"Error: File name is too long.", IDS_OPEN_FILE_ERROR:"Error: Cannot open file.", IDS_FILE_TOO_LARGE:"Error: The file size is too large.", IDS_TRANSFER_PEER_CANCEL:"#peer_name# cancels the file transfer.", IDS_PEER_NOT_FOUND:"Error: Cannot find the receiver.", IDS_PEER_LOW_VERSION:"Error: The receiver is using a low version messenger, which does not support 'File Transfer'.", 
  IDS_SEND_FAIL:"Error: Sending file fails.", IDS_RECV_FAIL:"Error: Receiving file fails.", IDS_READ_FILE_ERROR:"Error: Cannot read file.", IDS_TRANSFER_CANCEL:"The file transfer is canceled.", IDS_CANCEL_FILE_TRANSFER_ALERT:"All file transfer in this window will be canceled if you close it, do you want to continue?", IDS_INFO_EMOTICON:"To add/remove facial icons, edit file #filename#", IDS_LEAVE_GROUP:"#username# left the group conversation.", IDS_JOIN_GROUP_FAIL:"Cannot add #username# to the group conversation.", 
  IDS_ASYMMETRICAL_SHORT_MESSAGE:"The following message could not be delievered (You have disallowed the peer to see you. Please edit your profile to change this.) :", IDS_SHORT_MESSAGE_FAILURE:"The following message could not be delivered:", IDS_SHORT_MESSAGE_OFFLINE:"The following message is delivered as offline message (Only messenger 1.11 or higher can receive offline messages):", IDS_JOIN_GROUP:"#username# joined the group conversation.", IDS_GROUP_FINISH:"You left the group conversation.", 
  IDS_GROUP_CONVERSATION:"Group Conversation", IDS_NO_USER_ACCOUNT:"No user account.", IDS_DISCONNECT_IM2:"You are disconnected from the server. The IM text you sent just now could be lost. Please confirm with the receiver.", IDS_DISCONNECT_IM:"You are disconnected from the server.", IDS_DISCONNECT_GROUP:"You are forced to leave the group conversation due to network errror. You will be automatically reconnected when the network connection restores.", IDS_RECONNECT_IM:"You are reconnected to the server.", 
  IDS_FORMAT_CLOSE_CONVERSATION:"All conversation windows of Web Office #homepage# will be closed.", IDS_FORMAT_CONVERSATION_LOG:"Display Conversation Log with #username#", IDS_GROUP_ARE:"Group", IDS_USER_IS_TYPING:"#user# is writing...", IDS_USERS_ARE_TYPING:"#users# are writing...", IDS_IM_LOG_WARNING:"Information: the server is logging your message activity.", IDS_FORMAT_MISSED_CALL:"Missed Calls (%d)", IDS_NEW_MESSAGE:"You have new message(s)", IDS_DISKQUOTA_EXCEEDED:"Your disk quota was exceeded", 
  IDS_UPDATE_MESSENGER:"An update of messenger is available.", IDS_FORMAT_SHARE_FILE_DESCR:"Shared Recording File (%d)", IDS_FORMAT_PUBLISH_FILE:"Published Recording File (%d)", IDS_FORMAT_VISITOR:"Visitors (%d)", IDS_FORMAT_EVENT:"Scheduled Events (%d)", IDS_PREPARE_PLAYBACK_SHARE_FILE:"Prepare to playback shared recording file.", IDS_FORMAT_ALERT_SHARE_FILE2:"#username# @ #homepage# shares a recording file to you. Subject: #subject#, title: #title#, duration: %d min. Do you want to play this file?", 
  IDS_FORMAT_ALERT_SHARE_FILE:"#username# @ #homepage# shares a recording file to you. Title: #title#, duration: %d min. Do you want to play this file?", IDS_REMOVE_FILE_ALERT:"Are you sure to remove the shared recording file?", IDS_FORMAT_ALERT_VISITOR_SESSION:"#visitor# is leaving message in your office #office#.", IDS_FORMAT_ALERT_SHORT_MESSAGE2:"#visitor# @ #homepage# wrote:\r\n#message#", IDS_FORMAT_ALERT_SHORT_MESSAGE1:"#visitor# wrote:\r\n#message#", IDS_FORMAT_MISSED_CALL_VISITOR:"#time#, visitor: #visitor#", 
  IDS_FORMAT_MISSED_CALL_INVITATION:"#time#, invitation from: #invitor#", IDS_FORMAT_MISSED_CALL_NEW_MESSAGE:"#time#, new message received", IDS_FORMAT_MISSED_CALL_DISK_QUOTA:"#time#, disk quota was exceeded", IDS_FORMAT_MISSED_CALL_NEW_UPDATE:"#time#, messenger update was available", IDS_FORMAT_MISSED_CALL_SHORT_MESSAGE:"#time#, short message, #message#", IDS_FORMAT_EVENT_OWNER_NAME:"Meeting Owner: #ownername#", IDS_TIME_UNIT_MINUTE:"minutes", IDS_TIME_UNIT_HOUR:"hours", IDS_TIME_UNIT_DAY:"days", 
  IDS_FORMAT_EVENT_TIME_TO_START:"\nThis event will start in %d #time_unit#.", IDS_FORMAT_PUBLISHED_FILE:"From: #username#\nTitle: #title#\nDuration: %d min", IDS_FORMAT_PREPARE_JOIN_EVENT:"Prepare to visit #event#...", IDS_PREPARE_EDIT_PROFILE:"Prepare to edit profile...", IDS_PASSWORD_NOT_MATCH:"New password doesn't match", IDS_USERNAME_TOO_LONG:"User Name is too long", IDS_EMPTY_USERNAME:"User Name cannot be zero length", IDS_EMAIL_TOO_LONG:"Email is too long", IDS_PASSWORD_TOO_LONG:"Password is too long", 
  IDS_INVALID_OLD_PASSWORD:"Old password is invalid", IDS_FORMAT_OFFICE_INFO3:"Your User Information at Web Office (#office# &lt;#userid# @ #homepage#&gt;):\nServer Location: #ip#:%d\nUser Name: #username#\nEmail: #email#\nMax Allowed Connection: %d", IDS_FORMAT_OFFICE_INFO4:"Your User Information at Web Office (#userid# @ #homepage#):\nServer Location: #ip#:%d\nUser Name: #username#\nEmail: #email#\nMax Allowed Connection: %d", IDS_FORMAT_OFFICE_INFO5:"Your User Information at Web Office (#office# &lt;#userid# @ #homepage#&gt;):\nServer Location: #ip#:%d\nUser Name: #username#\nEmail: No Email\nMax Allowed Connection: %d", 
  IDS_FORMAT_OFFICE_INFO6:"Your User Information at Web Office (#userid# @ #homepage#):\nServer Location: #ip#:%d\nUser Name: #username#\nEmail: No Email\nMax Allowed Connection: %d", IDS_FORMAT_DISK_QUOTA:"\nDisk quota: %dM", IDS_NEW_CONTACT_GROUP_TITLE:"New Contact Group", IDS_RENAME_CONTACT_GROUP_TITLE:"Rename Contact Group", IDS_GROUP_NAME_EXIST:"The contact group name already exists.", IDS_PARTICAL_GROUP_IM:"Some members of the group are not eligible to join the group conversation, do you want to continue?", 
  IDS_DELETE_NONEMPTY_CONTACT_GROUP:"Contact group #contactgroup# is not empty, do you want to remove all the contacts in this group?", IDS_MODIFY_FILE_WARNING:"This file is shared. The share URL could be invalidated if you modify the file. Do you want to continue?", IDS_WEBOFFICE_EX_ERROR_INVALID_LICENSE:"Invalid license. (Please upgrade server license.)", IDS_WEBOFFICE_EX_ERROR_GENERAL_FAILURE:"The request fails.", IDS_WEBOFFICE_EX_ERROR_OPEN_FILE:"Cannot open the file.", IDS_WEBOFFICE_EX_ERROR_INVALID_JNR:"The file is not a valid recording file.", 
  IDS_WEBOFFICE_EX_ERROR_NOT_ALLOW_EDIT:"The file is not allowed to edit.", IDS_WEBOFFICE_EX_ERROR_FILE_ACCESS:"File access error.", IDS_ERROR_INVALID_PASSWORD:"Invalid Password.", IDS_WEBOFFICE_EX_ERROR_SERVER_SHUTDOWN:"The server is being shut down.", IDS_WEBOFFICE_EX_ERROR_WRITE_ERROR:"Write error.", IDS_ERROR_MEMORY_ALLOCATION:"Memory allocation failed.", IDS_WEBOFFICE_EX_ERROR_NETWORK_ERROR:"Network error.", IDS_WEBOFFICE_EX_ERROR_EXCEED_QUOTA:"Cannot upload: uploading this file would exceed the disk quota.", 
  IDS_WEBOFFICE_EX_DATE_TOO_NEW:"Cannot upload: the recorded date is too new for this server.", IDS_WEBOFFICE_EX_MMC_ERROR:"Error occurs at the third party server.", IDS_ERROR_UNKNOWN_ERROR:"Unknown Error.", IDS_MESSAGE_NOT_EXIST:"The recording file you specified does not exist.", IDS_ERROR_ALL_LINE_BUSY:"All lines are busy. Please try again later.", IDS_FORMAT_RATE2:"#size# of #total# at #rate#; #time# remain", IDS_WRITE_ERROR:"Cannot write the file.", IDS_READ_ERROR:"Cannot read the file.", IDS_ARCHIVE_WARNING:"The uploaded recording file will be archived by the system administrator. \nDo you want to continue?", 
  IDS_SHARE_ENCRYPTED_FILE:"The recording file is password-protected. Do you want to continue?", IDS_SHARE_FILE_FAILED:"Share recording file failed.", IDS_FORMAT_SHARE_FILE:"Share recording file of #office# to #target#", IDS_FORMAT_SHARE_FILE_TO_USER_TITLE:"Share file to #username# @ #homepage#", IDS_FORMAT_SHARE_FILE_TO_GROUP_TITLE:"Share file to #groupname# @ #homepage#", IDS_WEBOFFICE:"Web Office", IDS_UNSHARE_FILE_WARNING:"All the shared playback records will be deleted if you unshare this file. Do you want to continue?", 
  IDS_UNSHARE_FILE_FAILED:"Unshare recording file failed.", IDS_VIEW_RECORD_FAIL:"View shared playback record fails. Check with the server administrator.", IDS_PLAYBACK_FAIL:"Playback fails. Check with the server administrator.", IDS_FORMAT_SHARE_FILE_FALURE:"Share recording file to #username# failed.", IDS_TOO_BIG_CI:"#office#: Too many contacts or received shared recording files, please delete some.", IDS_FORMAT_INVITE_FALURE:"Your invitation to #username# failed.", IDS_FORMAT_ALERT_SHUTDOWN1:"Warning: web office #office# is being shut down. Please save your work.", 
  IDS_FORMAT_ALERT_SHUTDOWN2:"Warning: web office(#userid# @ #homepage#) is being shut down. Please save your work.", IDS_FORMAT_ALERT_SHUTDOWN3:"Warning: web office(guest @ #homepage#) is being shut down. Please save your work.", IDS_FORMAT_ALERT_MESSAGE_COUNT:"You have %d new messages in web office #office#", IDS_FORMAT_ALERT_DISKQUOTA1:"Your disk quota has been exceeded in web office #office#.", IDS_FORMAT_ALERT_DISKQUOTA2:"Your disk quota has been exceeded in web office(#userid# @ #homepage#).", 
  IDS_FORMAT_ALERT_NEW_MESSAGE1:"You have a new message from #visitor# in web office #office#.", IDS_FORMAT_ALERT_NEW_MESSAGE2:"You have a new message from #visitor# in web office(#userid# @ #homepage#).", IDS_MY_CONTACTS:"My Contacts", IDS_FORMAT_ALERT_SIGNIN1:"#username# @ #office# has just signed in.", IDS_FORMAT_ALERT_SIGNIN2:"#username# &lt;#userid#&gt; @ #office# has just signed in.", IDS_TOO_MANY_CONTACT:"Too many shared recording files at #office#. Not all of them can be saved to the server. Please delete some.", 
  IDS_TOO_MANY_CONTACT2:"Too many contacts at #office#. Not all of them can be saved to the server. Please delete some.", IDS_TOO_MANY_CONTACT3:"Too many contacts and shared recording files at #office#. Not all of them can be saved to the server. Please delete some.", IDS_FORMAT_TALKTO1:"You cannot talk to #username# when your office is busy.", IDS_FORMAT_TALKTO2:"Cannot talk to #username#.", IDS_ERROR_RESOLVE_IP:"Error in resolving the IP address.", IDS_ERROR_CAN_NOT_PARSE:"Can not parse the web office homepage.", 
  IDS_ERROR_CAN_NOT_CONNECT_HOMEPAGE1:"Can not connect to the web office homepage. Check the web office status and the proxy setting.", IDS_ERROR_CAN_NOT_DOWNLOAD_JNJ:"Can not download jnj file from the web office homepage. Try to use http://servername:port/ as the homepage.", IDS_ERROR_CAN_NOT_CONNECT_HOMEPAGE2:"Can not connect to the web office homepage. Check the web office status and the proxy setting.", IDS_ERROR_CAN_NOT_CONNECT_HOMEPAGE3:"Can not connect to the web office homepage. Check the web office status.", 
  IDS_ERROR_NO_MCU_SERVER:"No MCU server available.", IDS_ERROR_CAN_NOT_MULTIPLE_CONNECT:"Can not connect to the same web office multiple times. Please disconnect the existing connection first.", IDS_ERROR_CAN_NOT_CONNECT_MCU:"Can not connect to MCU.", IDS_ERROR_CONNECTION_BROKEN:"Connection with MCU is broken.", IDS_ERROR_BAD_SERVER_VERSION_STRING:"Unrecognized server version string.", IDS_ERROR_SERVER_NOT_SUPPORT_MSGR:"The server doesn't support JoinNet Messenger.", IDS_ERROR_INVALID_USERID_LEN:"Invalid User ID length.", 
  IDS_ERROR_INVALID_USERNAME_LEN:"Invalid User Name length.", IDS_ERROR_INVALID_JNJ_LEN:"Invalid jnj length.", IDS_ERROR_INVALID_HOMEPAGE_LEN:"Invalid homepage length.", IDS_ERROR_INVALID_PARAMETER:"Invalid parameter.", IDS_ERROR_INVALID_USERID:"Invalid User ID.", IDS_ERROR_ALREADY_SIGNIN:"The user already signed in.", IDS_ERROR_MSGR_VERSION_NOT_SUPPORTED:"This version of messenger is not supported.", IDS_ERROR_MSGR_BAD_CONFIGURATION:"The messenger service is not correctly configured.", IDS_ERROR_NO_MSGR_LICENSE:"The messenger service is not supported by the server license.", 
  IDS_ERROR_OVERWRITTEN:"You are overwritten by another connection.", IDS_ERROR_REMOVED:"You are removed from the web office server.", IDS_ERROR_INVALID_EMAIL_LEN:"Invalid Email length.", IDS_ERROR_INVALID_MMCERROR_LEN:"Invalid error text length.", IDS_ERROR_INVALID_INTERNALID_LEN:"Invalid internal userid length.", IDS_INVITE_FAILED:"Your invitation failed.", IDS_ERROR_INVALID_URL_LEN:"Invalid url length.", IDS_ERROR_INVALID_SHORT_MESSAGE_LEN:"Invalid short message length", IDS_ERROR_INVALID_CLIENT_INFO_LEN:"Invalid client info length.", 
  IDS_ERROR_UNKNOWN_COMMAND:"Unknown command.", IDS_NO_RESPONSE_FROM_OWNER:"No response from the web office owner.", IDS_OWNER_NOT_EXIST:"The web office owner doesn't exist.", IDS_CANNOT_JOIN_SELF:"Cannot join the web office of self.", IDS_OWNER_NOT_ONLINE:"The web office owner isn't online.", IDS_FORMAT_ERROR_PROMPT1:"Error in connection to #homepage# as guest. #error#", IDS_FORMAT_ERROR_PROMPT2:"Error in connection to #homepage# using id #userid#. #error#", IDS_FORMAT_ERROR_JOIN_REQUEST1:"Error in visit request to #username#: #error#", 
  IDS_FORMAT_ERROR_JOIN_REQUEST2:"Error in visit request to #username# &lt;#userid#&gt;: #error#", IDS_PROXY_ERROR_CONNECT_FAIL:"Cannot connect to the proxy server.", IDS_PROXY_ERROR_CONNECT_BROKEN:"Connection with the proxy server is broken.", IDS_PROXY_ERROR_NO_AUTH:"The socks5 proxy server require authentication, which is not supported yet.", IDS_PROXY_ERROR_NO_CONNECT:"Cannot connect to the mcu through the proxy server.", IDS_PROXY_ERROR_NOT_SOCKS5:"The proxy server is not a socks5 proxy.", IDS_PROXY_ERROR_HTTPS_FAIL:"The connection through the https proxy failed.", 
  IDS_PROXY_ERROR_RESOLVE:"Cannot resolve the proxy server.", IDS_ERROR_MMC_GENERAL:"Web request not passed.", IDS_ERROR_MMC_BAD_REQUEST:"Cannot generate web request.", IDS_ERROR_MMC_REQUEST_FAIL:"Web request failed.", IDS_ERROR_MMC_BAD_RESPONSE:"Bad web response.", IDS_ERROR_MMC_BAD_KEY:"Bad web key configuration.", IDS_ERROR_MMC_PARSE_RESPONSE:"Cannot parse the web response.", IDS_ERROR_MMC_UNKNOWN:"unknown web request error %d", IDS_FORMAT_SERVER_CONNECTION_STATUS:"Connection Status: #status#", 
  IDS_FORMAT_DISK_SPACE_USED:"Disk space used: %dM", IDS_PERSONAL_INFO:"Personal Message", IDS_CONNECTION_STATUS_INIT:"Initialized", IDS_CONNECTION_STATUS_RESOLVING:"Resolving", IDS_CONNECTION_STATUS_CONNECTTING:"Connecting", IDS_CONNECTION_STATUS_SIGN_IN:"Authentication", IDS_CONNECTION_STATUS_CONNECTED:"Connected", IDS_CONNECTION_STATUS_PREPARE_RECONNECT:"Prepare to reconnect", IDS_CONNECTION_STATUS_PARSE_HOMEPAGE:"Parsing web office homepage", IDS_CONNECTION_STATUS_DOWNLOAD_JNJ:"Downloading jnj file", 
  IDS_CONNECTION_STATUS_E_UNKNOWN_ERROR:"Error(unknown)", IDS_CONNECTION_STATUS_E_RESOLVING:"Error(cannot resolve server name)", IDS_CONNECTION_STATUS_E_FAIL_CONNECT:"Error(failed to connect)", IDS_CONNECTION_STATUS_E_BROKEN_CONNECT:"Error(connection is broken)", IDS_CONNECTION_STATUS_E_INVALID_S_STRING:"Error(invalid server string)", IDS_CONNECTION_STATUS_E_NOT_SUPPORTED:"Error(server doesn't support JoinNet Messenger)", IDS_CONNECTION_STATUS_E_WRONG_USERID_LEN:"Error(invalid userid length)", IDS_CONNECTION_STATUS_E_WRONG_USERNAME_LEN:"Error(invalid username length)", 
  IDS_CONNECTION_STATUS_E_WRONG_JNJ_LEN:"Error(invalid jnj length)", IDS_CONNECTION_STATUS_E_ERROR_PARAMETER:"Error(error in parameter)", IDS_CONNECTION_STATUS_E_BUSY:"Error(all lines are busy)", IDS_CONNECTION_STATUS_E_INVALID_USERID:"Error(invalid user)", IDS_CONNECTION_STATUS_E_INVALID_PASSWORD:"Error(invalid password)", IDS_CONNECTION_STATUS_E_MEMORY_ALLOCATION:"Error(memory allocation failure)", IDS_CONNECTION_STATUS_E_ALREADY_LOGGED:"Error(already logged in)", IDS_CONNECTION_STATUS_E_OVERWRITTEN:"Error(being overwritten by other user)", 
  IDS_CONNECTION_STATUS_E_USERID_REMOVED:"Error(being removed from the server)", IDS_CONNECTION_STATUS_E_UNKNOWN_COMMAND:"Error(disconnected by unknown command)", IDS_CONNECTION_STATUS_E_WRONG_EMAIL_LEN:"Error(invalid email length)", IDS_CONNECTION_STATUS_E_PARSE_HOMEPAGE:"Error(cannot parse the web office homepage)", IDS_CONNECTION_STATUS_E_DOWNLOAD_JNJ:"Error(failed to download jnj file from homepage)", IDS_CONNECTION_STATUS_E_PARSE_IP_PORT:"Error(cannot parse server address from jnj file)", IDS_CONNECTION_STATUS_E_BREAK_MAIN_LOOP:"Disconnected", 
  IDS_CONNECTION_STATUS_E_WRONG_HOMEPAGE_LEN:"Error(invalid homepage length)", IDS_CONNECTION_STATUS_E_MULTIPLE_SIGNIN:"Error(cannot connect to a web office with multiple connections)", IDS_CONNECTION_STATUS_E_PROXY_CONNECT_FAIL:"Error(Cannot connect to the proxy server)", IDS_CONNECTION_STATUS_E_PROXY_CONNECT_BROKEN:"Error(Connection with the proxy server is broken)", IDS_CONNECTION_STATUS_E_PROXY_NO_AUTH:"Error(The socks5 proxy server require authentication, which is not supported yet)", IDS_CONNECTION_STATUS_E_PROXY_NO_CONNECT:"Error(Cannot connect to the mcu through the proxy server)", 
  IDS_CONNECTION_STATUS_E_PROXY_NOT_SOCKS5:"Error(The proxy server is not a socks5 proxy)", IDS_CONNECTION_STATUS_E_PROXY_HTTPS_FAIL:"Error(The connection through the https proxy failed)", IDS_CONNECTION_STATUS_E_PROXY_RESOLVE:"Error(Cannot resolve the proxy server)", IDS_CONNECTION_STATUS_E_MMC_FAILURE:"Error(web request failed)", IDS_CONNECTION_STATUS_E_NOT_SUPPORTED2:"Error(This version of messenger is not supported)", IDS_CONNECTION_STATUS_E_NO_MESSENGER:"Error(The messenger service is not correctly configured.)", 
  IDS_CONNECTION_STATUS_E_NO_LICENSE:"Error(The messenger service is not supported by the server license.)", IDS_CONNECTION_STATUS_E_NO_MCU:"Error(No MCU server available)", IDS_CONNECTION_STATUS_E_WRONG_URL_LEN:"Error(invalid url length)", IDS_CONNECTION_STATUS_E_WRONG_SHORT_MESSAGE_LEN:"Error(Invalid short message length)", IDS_CONNECTION_STATUS_E_SIGNOUT:"Error(You have signed out)", IDS_CONNECTION_STATUS_E_WRONG_CLIENT_INFO_LEN:"Error(Invalid client info length)", IDS_CONNECTION_STATUS_E_DEFAULT:"Error", 
  IDS_TOOLTIP_CLOSE:"Close", IDS_TOOLTIP_IM_LAUNCH:"Launch Web Office", IDS_TITLE:"Title", IDS_COL_DURATION:"Duration", IDS_FORMAT_TALK_TO:"Talk to #username#", IDS_MENU_FOLD:"Fold", IDS_MENU_UNFOLD:"Unfold", IDS_START_GROUP_IM:"Start Group Conversation", IDS_COL_LAST_START_TIME:"Last Playback", IDS_COL_PLAYER:"Player Name", IDS_COL_USERID:"User ID", IDS_FORMAT_FILE_TO_RECEIVE:"File to receive: %d", IDS_DOWNLOAD_MORE:"Download More", IDS_DOWNLOAD_ALL:"Download All", IDS_SERVER_LOG_ERROR_TEXT:"Error #text#", 
  IDS_SERVER_IM_LOG:"Server Conversation Log", IDS_FORMAT_IM_TOTAL:"Total: %d (%s)", IDS_ERROR:"Error", IDS_SEND_FILE:"Send File", IDS_RECV_FILE:"Recv File", IDS_JOIN:"Join", IDS_LEAVE:"Leave", IDS_COL_IM_TIME:"Time", IDS_COL_NAME:"Name", IDS_COL_TEXT:"Text", IDS_FORMAT_PGC_DESCR:"Group Conversation (%d)", IDS_SHOW_PGC:"Show Group Conversation", IDS_HIDE_PGC:"Hide Group Conversation", IDS_RENAME_PGC:"Rename Group Conversation", IDS_LEAVE_PGC:"Leave Group Conversation", IDS_RENAME_PGC_PROMPT:"Please input the name here:", 
  IDS_PGC_NAME_TOO_LONG:"The name is too long.", IDS_RENAME_PGC_DESCR:"#username# rename the group conversation to #text#", IDS_WEBOFFICE_EX_UNKNOWN_CMD:"Editing error, unknown request.", IDS_WEBOFFICE_EX_INVALID_CMD:"Editing error, invalid request.", IDS_WEBOFFICE_EX_JNR_TOONEW:"Editing error, the recording file is too new, please upgrade the server.", IDS_WEBOFFICE_EX_JNR_TOOBIG:"Editing error, the file would be too big, please do some cutting first.", IDS_WEBOFFICE_EX_EDIT:"Editing error, please use Jeditor.", 
  IDS_SHORT_MESSAGE_PROMPT:"Input your short message here (Limit: 100 characters):", IDS_SEND_SHORT_MESSAGE_TITLE_FOR_GROUP:"Send message to #groupname#", ID_APP_NAME:"JoinNet Messenger", ID_OK:"OK", ID_CANCEL:"Cancel", IDD_DIALOG_SHARE_RESULT_OK:"Copy URL", IDS_FORMAT_GROUP_TOTAL:"Statistics for group #group# - Total files: %d; Total duration: %d min; Total size: #size#; Total view count: %d", IDC_CHECK_REMEMBER_PASSWORD:"Remember the password", ID_RECONNECT_ALL:"Reconnect All", ID_YES:"Yes", ID_NO:"No", 
  ID_TEXT_SIZE:"Text Size", ID_ABOUT:"About", ID_INVITATION_REQUEST:"Invitation Request", ID_VISIT_REQUEST:"Visiting Request", ID_SHOW_LOG_FOLDER:"Show Log Folder", ID_MARK_SELECTED_AS_READ:"Mark #target# As Read", ID_MARK_SELECTED_AS_UNREAD:"Mark #target# As Unread", ID_DELETE_SELECTED:"Delete #target#", ID_READ:"Read", ID_UNREAD:"Unread", ID_ENCRYPTED:"Encrypted", ID_SHARED:"Shared", ID_RESET_SELECTION:"Reset Selection", ID_SIZE:"Size", ID_PREV:"Prev", ID_NEXT:"Next", ID_PREV10000:"Prev 10000", 
  ID_NEXT10000:"Next 10000", ID_PREV1000:"Prev 1000", ID_NEXT1000:"Next 1000", ID_PREV100:"Prev 100", ID_NEXT100:"Next 100", ID_PREV10:"Prev 10", ID_NEXT10:"Next 10", ID_OPERATION:"Operation", ID_ASCENDING:"Ascending", ID_DESCENDING:"Descending", ID_SORTING:"Sorting", ID_SEND_MESSAGE:"Send Message", ID_CLOSE_CONVERSATION:"Close Conversation", ID_CLOSE_CONVERSATION_LOG:"Close Conversation Log", ID_SAVE_CONVERSATION:"Save Conversation", ID_EMAIL_CONVERSATION:"Email Conversation", ID_DISPLAY_LOG:"Display Conversation Log", 
  ID_CONVERSATION_LOG:"Conversation Log", ID_BOLD:"Bold", ID_ITALIC:"Italic", ID_UNDERLINE:"Underline", ID_STRIKE:"Strikeout", ID_SAMPLE:"Sample:", ID_COLOR:"Color:", ID_SPINNER_COLOR_PROMPT:"Choose a color", ID_IMSTYLE:"Text Style", ID_FILE_CHOOSER_TITLE:"Select a file to transfer", ID_PICK_USER:"Pick User", ID_SHARE_FILE:"%s share JNR File to you", ID_VISITOR_ALERT:"You have a visitor", ID_SHORT_MESSAGE:"Short Message", ID_JOIN_EVENT:"Join Event", ID_CGL_CHOOSER_TITLE:"Select a contact group file to import", 
  ID_CONTACT_EXPORTED:"Contact are exported to #path#.", ID_JNR_DOWNLOADING:"The recording file will be downloaded to #path#", ID_JNR_CHOOSER_TITLE:"Select a recording file to upload", ID_SET_GROUP_SELECTED:"Set Group #target#", ID_CASE_SENSITIVE:"Case Sensitive", ID_CUMULATIVE_PLAYBACK_TIME:"Total Time", ID_LANG_TITLE:"Language", ID_VIBRATE:"Vibrate when showing alert", ID_INSISTENT_ALERT:"Insistent alert for visit and invitation", ID_ALERT_ONLINE_TITLE:"Alert Online", ID_ALERT_NEWMESSAGE_TITLE:"Alert New Message", 
  ID_PLAY_SOUND_TITLE:"Play Sound", ID_VIBRATE_TITLE:"Vibrate", ID_INSISTENT_ALERT_TITLE:"Insistent Alert", ID_EXIT_PROMPT:"Are you sure to exit JoinNet Messenger?", ID_CONVERSATION_IS_SAVED:"The conversation is saved to file #path#", ID_SAVED_CONVERSATION_FILENAME:"saved_conversation.txt", ID_COPYRIGHT:"Copyright &#169; 2014", ID_FORMAT_SELECTED_COUNT:"%d Selected", ID_FORMAT_LOADING:"Loading(%d Received)...", ID_FORMAT_ITEM_POSITION:"#number# out of #total_count#", ID_WARNING_DELETE_JNR:"Are you sure to delete this recording file?", 
  ID_WARNING_DELETE_SELECTED_JNR:"Are you sure to delete the selected recording files?", ID_WARNING_DELETE_IM:"Are you sure to delete this file?", ID_WARNING_DELETE_SELECTED_IM:"Are you sure to delete the selected files?", ID_FORMAT_TRANSFER_TITLE:"File transfer from #peer_name#", ID_FORMAT_TRANSFER_CONTENT:"#file_name#, size #file_size#.", ID_FILE_NOT_FOUND:"#file# is not found", ID_FILE_NO_INTENT:"Don't know how to open #file#, please open it manually.", ID_FORMAT_SERVER_VERSION:"Server Version", 
  ID_FORMAT_MESSENGER_VERSION:"Messenger Version", ID_VISIT:"Visit", ID_INVITE:"Invite", ID_PGC_ALERT:"Use persistent group conversation", IDS_SIP_VIA:" via ", IDS_PUBLIC_VIEW:"Public View", IDS_SELFVIEW:"Selfview", IDS_RECORDEDVIEW:"Recorded Video", IDS_BAN_USERID:"Permanently disconnect this user?", ID_CLOSE:"Close", IDS_SIP_JOIN_REQUEST_FORMAT:"Do you accept %1$s's join request via %2$s?", IDS_SHADOW_REQUEST_FORMAT:"Do you accept %1$s's join request?", ID_ACCEPT:"Accept", ID_REJECT:"Reject", ID_QUESTION_NITIFICATION:"Question request", 
  IDS_SNAPSHOT:"Snapshot", IDS_SYSTEM_CODE:"System code %1$d", IDS_UNKNOWN_ERROR:"Unknown error", IDS_FAIL_CONNECT_MCU:"Cannot connect to MCU server.", IDS_NO_SCHEDULE:"No session scheduled for you.", IDS_WRONG_IP_PASSWD:"Your IP address is not supported by this server.", IDS_WRONG_AUTH_PASSWD:"Your are not authorized to join this event.", IDS_MEETING_NOT_EXIST2:"Sorry, the session you specified can not be found.", IDS_TOOMANY_USER_2:"There are too many users in the chat room.", IDS_CONNECTION_ESTABLISHED:"Connection established", 
  IDS_DISCONNECT_BY_OWNER:"You are disconnected by the Meeting Owner.", IDS_MEETING_OVER:"Session is Over.", IDS_USER_OVERWRITE:"You are disconnected because your name is reused by others.", IDS_FILE_READ_ERROR:"Cannot read the recording file.", IDS_FILE_PAGE_ERROR:"Cannot read the recording file because of page error, \r\nCheck the file status.", IDS_JN_CORRUPT_SERVER_PARAMETER:"Invalid MCU Server Parameter", IDS_JN_DELETE_FILE_OK:"The Recording File is deleted.", IDS_JN_DELETE_FILE_FAIL:"The Recording File can not be deleted.", 
  IDS_CAN_NOT_READ_JNJ:"JoinNet can not read the passed .jnj file. One possible reason is that the Browser cache is full. Try again after cleaning the cache.", IDS_UNKNOWN_CODETYPE:"Unknow codetype in .jnj file. You may need to upgrade your JoinNet version.", IDS_RECORDING_FILE_ERROR:"The recording file is corrupted or it contains some unrecognized command", IDS_WARNING_MEETING_TERMINATED:"The meeting will be terminated in a few minutes", IDS_PREPARATION_MODE:"The meeting is in preparation mode.\r\nOnly slides are recorded and will be transfered into the normal meeting later.", 
  IDS_PREPARATION_SWITCH_TO_NORMAL:"The meeting is switched into normal meeting mode from preparation mode!", IDS_FAIL_CONNECT_PROXY:"Cannot connect to the Proxy Server.", IDS_CONNECT_PROXY_BROKEN:"The connection with the Proxy Server is broken.", IDS_CONNECT_PROXY_NO_AUTH:"The the Proxy Server does not accept the authentication method.", IDS_CONNECT_PROXY_NO_CONNECT_GC:"Cannot connect to GC server through the Proxy Server.", IDS_CONNECT_PROXY_NO_UDP_ASSOCIATION:"UDP Association request to the Proxy Server failed.", 
  IDS_CONNECT_PROXY_NOT_SOCKS5:"The SOCKS proxy server is not version 5.", IDS_ERROR_PROXY_HTTPS_FAILED:"Connection request through HTTPS proxy server failed.", IDS_NO_USERID:"There is no such a userid.", IDS_WRONG_PASSWD:"Invalid password.", IDS_ALREADY_LOGGED:"This user has already logged in.", IDS_ILLEGAL_PARAM:"Illegal Parameter.", IDS_WRONG_SESSIONID:"Illegal Session ID.", IDS_MEETING_NOT_EXIST:"The session you specified is over or is not started yet.", IDS_INTERNAL_ERROR:"Internal error at MCU server.", 
  IDS_FILE_ERROR:"Cannot open the recorded file", IDS_TOOMANY_PLAYBACK:"There are too many playback requests to the server.\r\nPlease try later.", IDS_ILLEGAL_FILE:"Cannot open file: it does not appear to be a valid JoinNet Recording File.\r\nIf you downloaded this file, try downloading the file again.", IDS_WRONG_PASSWD2:"Invalid password, or MCU server date mismatch with GC server.", IDS_TOOMANY_DOWNLOAD:"There are too many download requests to the server.\r\nPlease try later.", IDS_TOOMANY_USER:"There are too many users in the session.", 
  IDS_CALL_REJECTED:"Your join request is rejected.", IDS_CALL_NOT_ACCEPTED:"Your join request is not accepted.", IDS_WRONG_JOINNET_MODE:"The Meeting Server does not provide this service. Please contact HomeMeeting for more information.", IDS_SESSION_CLOSED:"This session is already over.", IDS_SERVER_BUSY:"The server is busy. Please try again later.", IDS_CAN_NOT_RECORD:"Cannot leave message due to insufficient disk space at server.", IDS_LINE_BUSY:"All lines are busy. Please try again later.", IDS_ERROR_EXCEED_DISK_QUOTA:"Disk quota is exceeded.", 
  IDS_ERROR_WRONG_USERINFO2:"Authentication fails.", IDS_ERROR_OWNER_IN_PREPARATION_MODE:"The owner is preparing the meeting.\r\nTry again later.", IDS_ERROR_PREPARATION_MODE_TOO_LATE:"The meeting has started,\nit's too late to prepare this meeting.", IDS_ERROR_ILLEGAL_REQUEST:"Illegal service request.", IDS_ERROR_MCU_OUT_OF_MEMORY:"The MCU server cannot provide the service because its virtual memory is dangerously low!", IDS_MCU_RELAY_ERROR_CONTINUE:"Info: There are more data after this.", IDS_MCU_RELAY_ERROR_SLIDENOTREADY:"Cannot download slide because the slide is not downloaded into the MCU relay's cache yet.", 
  IDS_PROXY_FAIL_CONNECT_MCU:"Unable to connect to the MCU. It is recommended to check your proxy settings.", IDS_CONNECTION_REFUSED:"The connection is refused when attemping to contact the server.", IDS_ERROR_INVALID_LICENSE:"Invalid license. (Please upgrade server license.)", IDS_ERROR_REQUEST_REJECTED:"Your request is rejected.", IDS_IMAGE_TOO_BIG:"The size of the image is too big for the mark!", IDS_IN_UPLOADING:"There is a slide uploading now, please wait......", IDS_DELETE_SLIDE:"Are you sure you want to delete this slide?", 
  IDS_DELETE_WHOLE_SLIDE:"Do you also want to delete all the pages in the current document?", IDS_DELETE_FILE:"Are you sure you want to delete this file?", IDS_DURATION_STRING:"%1$ 2d:%2$02d", IDS_DURATION_STRING_2:"Time to start: %1$ 2d:%2$02d", IDS_LEAVE_MESSAGE:"%1$s is not online, please leave your message.", IDS_LEAVE_MESSAGE_OWNER_REJECT:"%1$s is busy, please leave your message.", IDS_CLEAR_ALL_MARK:"Clear all the marks contained on this slide?", IDS_MAIN_TITLE:"Meeting Room", IDS_WANT_TO_END:"As the meeting owner,\n\nDo you also want to end this %1$s?", 
  IDS_ALLOCATE_CHANNEL_FAIL:"Unable to allocate network channel for the application. Error code %1$d.", IDS_TRY_RECONNECT:"Your network is disconnected from MCU server.\nDo you want to reconnect?", ID_CANCELUPLOAD:"Do you want to cancel the upload?", ID_CANCELDOWNLOAD:"Do you want to cancel the download?", ID_FILEOVERWRITEPROMPT:"%1$s already exists.\nDo you want to replace it?", ID_ERROR_OUTOFMEMORY:"Not enough memory is available to complete this operation.", IDS_FAIL_TO_CONVERT_FILE:"The server does not recognize the format of %1$s.", 
  IDS_RDC_NO_RESPONSE:"No response from the selected user.", IDS_POLL_RESULT_FORMAT:"Total Users: %1$d, Not Responding Users: %2$d\n", IDS_UPLOAD_POLL_RESULT:"Do you want to upload the Poll Statistics to the Interactive Board?", IDS_REMIND_CONTROL:"The token holder allows you to remotely control the windows of %1$s.", IDS_ASSISTANT_FAILED_DISCONNECT:"Unable to change the assistant rule because you have already been disconnected from the MCU server.", IDS_USER_NOT_IN_THE_MEETING:"The user you select is not in the meeting anymore.", 
  IDS_LEAVE_THE_MEETING:"Do you want to leave the meeting?", IDS_WAIT_TO_TALK:"Wait to talk for the permission by the token holder.", IDS_WAIT_PERMISSION:"Waiting for permission...", IDS_WAIT_OWNER_RESPONSE:"Waiting for %1$s's response...", ID_SENDTEXTTO:"Send to: ", IDS_EVERYONE:"Everyone", ID_CONTROLLER:"Controller", ID_CONTROLLED:"Controlled", ID_DUMMY:""});
}]);

// sourceMappingURL=hmtgs.min.js.map 
